import 'dart:async';
import 'dart:io';
import 'package:audio_waveforms/audio_waveforms.dart';
import 'package:collection/collection.dart';
import 'package:date_field/date_field.dart';
import 'package:flutter/foundation.dart' as found;
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';
import 'package:observable/observable.dart';
import 'package:uuid/uuid.dart';
import 'package:video_player/video_player.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/XfxToolTips.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxwidgets/XF_MAIN/XApp.dart';
import 'package:xfxwidgets/XF_MAIN/XAppState.dart';
import 'package:xfxwidgets/xMediaItem.dart';
import 'package:xtoolspackage/XLibStorage.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:video_thumbnail/video_thumbnail.dart' as thumb;
// import 'package:image_painter/image_painter.dart';
import 'package:image/image.dart' as img;

import '../ImagePainter/ImagePainter.dart';
import '../XF_SCHEDA/Xfx_Scheda.dart';
import '../XMediaRecorder.dart';
import '../XfxDropDown.dart';
import '../xfxwidgets.dart';

// extension WhereMethod<K> on Iterable<K>? {
//   Iterable<K> whereMethod({bool Function(K)? fun}) {
//     if (this != null && fun != null) {
//       return this!.where(fun);
//     } else if (this == null) {
//       return [];
//     } else {
//       return this!.toList();
//     }
//   }
// }

class XElenco<T extends StatefulWidget, K extends XFDataItem> extends StatefulWidget {
  XElenco(
    this.title_Text,
    this.view, {
    Key? key,
    this.xApp,
    this.viewDetts,
    this.title_OnTop_Visible = false,
    this.headers_Visible = false,
    this.filters_Visible = false,
    this.heightForHeader,
    this.headers,
    this.filters,
    this.numberOfHeader,
    this.flexForList,
    this.colorBackgroundContainerElTitle,
    this.heightContainerElTitle,
    this.title_Style,
    this.BTNtitle_Label,
    this.BTNtitle_Color,
    this.BTNtitle_OnPressed,
    this.BTNtitle_Height,
    this.BTNtitle_Width,
    this.BTNtitle_Visible = false,
    this.BTNtitle_Margin,
    this.margin_Horizontal,
    this.onRefresh_ScrollDownList,
    this.item_Widget,
    this.floatingActionButton,
    this.searchBar_Active = true,
    this.allowAdd = false,
    this.cmd_Add,
    this.onDoubleTapItem,
    this.pageMode_Active = true,
    this.onTapItem,
    this.schNameToOpen,
    this.formatDate,
    this.liDetts,
    this.xDrawerMenu,
    this.appBar_Color,
    this.searchBar_Color,
    this.searchBar_ColorBorder,
    this.searchBar_ColorHint,
    this.searchBar_ColorIconClear,
    this.searchBar_ColorIconSearch,
    this.searchBar_ColorText,
    this.searchBar_hintText,
    this.searchBar_whereMethod,
    this.onPressed_MENU,
    this.liPopUpMenu_Items,
    this.itemSelected_BackGroundColor,
    this.elDettsMode_SchItem,
    this.liDettsSubArea_Widgets,
    this.edited,
    this.xOnReturnBack,
    this.noTextWhenCellValueIsNull = false,
    this.title_Color,
    this.onEditBoolValueOnItem,
    this.liWidgets_LeftArea_Item,
    this.schedaMode = false,
    this.itemEdited,
    this.rootItemEdited,
    this.onLongTapItem,
    // this.whereMethod,
    this.BTNEmptyList_BL,
    this.showHead_DettsRowInItem = true,
    this.xDett_xColname,
    this.appBar_Height,
    this.xDettItem_BackGroundColor,
    this.widgetBuild_Override,
    this.appBar_Visible = true,
    this.liWidgets_RightArea_Item,
    this.showHead = true,
    this.liXActions,
    this.xDett_minHeight_showHead = true,
    this.xDett_AddBTN_Active = true,
    this.liXMediaToUse,
  }) : super(key: key);
  XView? view;
  XView? viewDetts;
  XApp? xApp;
  double? margin_Horizontal;
  Future<void> Function(BuildContext)? onRefresh_ScrollDownList;
  //viene modificato un XFDataItem a qualsiasi livello
  Function(XFDataItem)? itemEdited;
  //viene modificato un XFdataItem root = K
  Function(K)? rootItemEdited;
  Function()? BTNEmptyList_BL;
  bool title_OnTop_Visible;
  bool headers_Visible;
  bool? filters_Visible;
  bool showHead_DettsRowInItem;
  String? xDett_xColname;
  double? heightForHeader;
  String? formatDate;
  List<Widget>? headers = List<Widget>.empty(growable: true);
  List<Widget>? filters = List<Widget>.empty(growable: true);
  int? numberOfHeader;
  int? flexForList;
  Color? colorBackgroundContainerElTitle;
  double? heightContainerElTitle;
  String title_Text;
  TextStyle? title_Style;
  Color? title_Color;
  String? BTNtitle_Label;
  Color? BTNtitle_Color;
  Function()? BTNtitle_OnPressed;
  double? BTNtitle_Height;
  double? BTNtitle_Width;
  bool? BTNtitle_Visible;
  EdgeInsets? BTNtitle_Margin;
  Widget? Function(K)? item_Widget;
  Color? appBar_Color;
  Widget? floatingActionButton;
  Widget? xDrawerMenu;
  Widget? Function(dynamic)? liDettsSubArea_Widgets;
  Function(void Function(void Function()))? xOnReturnBack;
  bool searchBar_Active;
  Color? searchBar_ColorHint;
  Color? searchBar_ColorText;
  Color? searchBar_ColorIconClear;
  Color? searchBar_ColorIconSearch;
  Color? searchBar_Color;
  Color? searchBar_ColorBorder;
  String? searchBar_hintText;
  List<Widget>? Function(K)? liWidgets_LeftArea_Item;
  List<Widget>? Function(K)? liWidgets_RightArea_Item;
  bool Function(K, String)? searchBar_whereMethod;
  ValueNotifier<bool>? edited;
  bool allowAdd;
  bool? schedaMode;
  double? appBar_Height;
  Function(void Function(void Function()))? cmd_Add;
  Function()? onDoubleTapItem;
  Function(K)? onTapItem;
  Function(dynamic)? onLongTapItem;

  Function()? onPressed_MENU;
  String? schNameToOpen;
  Function(XCol, bool)? onEditBoolValueOnItem;
  Color? itemSelected_BackGroundColor;
  Color? xDettItem_BackGroundColor;

  bool noTextWhenCellValueIsNull;
  bool pageMode_Active;
  bool? elDettsMode_SchItem;
  bool appBar_Visible;
  Widget? widgetBuild_Override;

  bool? borderAree_Header;
  bool showHead;
  bool xDett_minHeight_showHead;
  bool xDett_AddBTN_Active;

  List<XPopUpMenuItem>? liPopUpMenu_Items = List<XPopUpMenuItem>.empty(growable: true);
  List<XAction>? liXActions = List<XAction>.empty(growable: true);
  List<dynamic>? liDetts;

  ///elenco XMedia in carico alla scheda che questo elenco deve usare
  final List<XMediaItem>? liXMediaToUse;

  //bool Function(K, String?)? whereMethod;
  @override
  XElencoState<T, K> createState() => XElencoState<T, K>();
}

class XElencoState<T extends StatefulWidget, K extends XFDataItem> extends State<XElenco<T, K>> with SingleTickerProviderStateMixin {
  ScrollController? scroll_controller = ScrollController();
  TextEditingController searchController = TextEditingController();

  Future<List<K>> Function()? xLoadData_apiCall = null;
  List<K> Function()? xLoadData_get = null;
  List<K> list = List<K>.empty(growable: true);
  ObservableList<K>? xListSourceObservable;

  List<XMediaItem> liMediaRAW = List<XMediaItem>.empty(growable: true);
  List<K> liDelItems = List<K>.empty(growable: true);

  ValueNotifier<bool> isBusy = ValueNotifier(true);
  Color? cell_borderColor;
  Color? cell_borderColor_Disabled;
  Color? cell_labelColor_Disabled;
  static String filterAll = "TUTTI";
  String filterCurrent = "";
  String? filterValue;
  Timer? timerSearch;

  found.ValueListenable<List<XMediaItem>> liXMedias_MediaRecorder = ValueNotifier<List<XMediaItem>>(List<XMediaItem>.empty(growable: true));
  String xFormat_Date = "dd/MM";

  AnimationController? _swipingAnimationController;
  bool xMedia_Active = false;

  String waiterMessage = "";
  //Per gestire EditDialog
  List<XProp> xEditDialog_liProps = List<XProp>.empty(growable: true);
  String xEditDialog_EditCell = "";
  bool borderColor_Active = false;

  List<XProp> xFilter_SearchBarXCols = List<XProp>.empty(growable: true);
  List<XProp> xFilter_OrderBy_XProps = List<XProp>.empty(growable: true);
  List<XFilterEl<dynamic>> xFilter_XFilters = List<XFilterEl<dynamic>>.empty(growable: true);

  //Per Audio
  // List<AudioPlayer>? audioPlayers;
  int selectedPlayerIdx = 0;
  // FlutterSoundRecorder? _audioRecorder = FlutterSoundRecorder();
  // AudioPlayer get selectedAudioPlayer => audioPlayers![selectedPlayerIdx];
  final _imageKey = GlobalKey<ImagePainterState>();
  final _imageBlockNote_Key = GlobalKey<ImagePainterState>();
  final _imagePainterState_Key = GlobalKey<ImagePainterState>();
  final _imagePainterBlockNoteState_Key = GlobalKey<ImagePainterState>();

  bool? createAudio = false;
  File? xFileUI;
  File? file;

  late PlayerController playerController;
  late StreamSubscription<PlayerState> playerStateSubscription;

  final playerWaveStyle = const PlayerWaveStyle(
    fixedWaveColor: Colors.white54,
    liveWaveColor: Colors.white,
    spacing: 6,
  );

  double actionsBTN_Width = 35;
  double actionsBTN_Height = 35;
  Color actionsBTN_Color = Color.fromARGB(255, 27, 27, 27);
  Color actionsBTN_BorderColor = Colors.transparent; // Colors.grey[600]!;

  late VideoPlayerController? videoPlayerController;

  late bool xMedia_Loading;
  late final ValueNotifier<bool> _isLoaded;

  @override
  void initState() {
    if (widget.liXActions == null) {
      widget.liXActions = List<XAction>.empty(growable: true);
    }
    _isLoaded = ValueNotifier(true);
    if (widget.edited == null) {
      widget.edited = ValueNotifier(false);
    }
    xLoadDataOnly();
    initXFilters();
    widget.view!.cols.forEach((element) {
      if (xFilter_OrderBy_XProps.any((xProp) => xProp.col_Name == element.colKey)) {
        element.sorted = true;
      }
    });
    if (widget.liDetts != null) {
      for (var xProp in xFilter_OrderBy_XProps) {
        widget.liDetts!.orderBy([xProp.col_Name], desc: (widget.view!.cols.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
      }
    } else {
      for (var xProp in xFilter_OrderBy_XProps) {
        list.orderBy([xProp.col_Name], desc: (widget.view!.cols.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
      }
    }

    // audioPlayers = [AudioPlayer(playerId: "1")];
    _swipingAnimationController = AnimationController(duration: const Duration(milliseconds: 200), vsync: this);
    searchController.addListener(
      () {
        setState(() {
          filterValue = searchController.text;
          if (timerSearch != null) timerSearch!.cancel();
          timerSearch = Timer(Duration(milliseconds: 300), timerSearchHandlerList);
        });
      },
    );
    if (xListSourceObservable != null) {
      xListSourceObservable!.changes.listen((event) {
        // if (this.context.mounted)
        neededRealoadData = true;
        //   xLoadDataOnly();
        // else
        // neededRealoadData = true;
      });
    }
    if (widget.liXMediaToUse != null) {
      // xMedia_Loading = true;
      liMediaRAW = widget.liXMediaToUse!;
      // Future.forEach(liMediaRAW, (xm) async => await loadMedia(xm)).then((value) => xMedia_onFinishLoading());
    }
    super.initState();
    playerController = PlayerController();
    playerStateSubscription = playerController.onPlayerStateChanged.listen((_) {
      setState(() {});
    });
  }

  xMedia_onFinishLoading() {
    setState(() {
      xMedia_Loading = false;
    });
  }

  void _preparePlayer(XMediaItem item) async {
    // Opening file from assets folder
    var dir = Directory("${XLibStorage.filePath}/XMEDIAS/");
    if (dir.existsSync()) {
      var liFiles = dir.listSync();
      var rawFile = liFiles.firstWhereOrNull((e) => e.path.split(".")[0].contains(item.id));
      //Se il file non esiste lo creo e lo riempo con quello che mi ritorna dalle API
      if (rawFile == null) {
        file = await File("${XLibStorage.filePath}/XMEDIAS/${item.id}_.${extForMediaType(item.mediaType!)}").create();
        var x = await xOnGetXMedia(item).then((x) {
          if (x != null) {
            item.payload = x.payload;
          }
        });
        await file?.writeAsBytes(item.payload!);
      } else {
        //Se esiste gia fillo solo la variabile che uso come appoggio
        file = File(rawFile.path);
      }
    } else {
      //Se invece non esiste ancora la cartella XMedia creo la cartella, prendo il payload e lo riempo
      file = await File("${XLibStorage.filePath}/XMEDIAS/${item.id}_.${extForMediaType(item.mediaType!)}").create();
      var x = await xOnGetXMedia(item).then((x) {
        if (x != null) {
          item.payload = x.payload;
        }
      });
      await file?.writeAsBytes(item.payload!);
    }

    // Prepare player with extracting waveform if index is even.
    await playerController.preparePlayer(path: file!.path, shouldExtractWaveform: true);
    // Extracting waveform separately if index is odd.
    await playerController.extractWaveformData(path: file!.path, noOfSamples: playerWaveStyle.getSamplesForWidth(200)).then((waveformData) => debugPrint(waveformData.toString()));
  }

  void _preparePlayer_WhenInPreview(XMediaItem item) async {
    // Opening file from assets folder
    var liFiles = Directory("${XLibStorage.filePath}/XMEDIAS/").listSync();
    var rawFile = liFiles.firstWhereOrNull((e) => e.path.split(".")[0].contains(item.id));
    file = File(rawFile!.path);
    await file?.writeAsBytes(file!.readAsBytesSync());
    // Prepare player with extracting waveform if index is even.
    await playerController.preparePlayer(path: file!.path, shouldExtractWaveform: true);
    // Extracting waveform separately if index is odd.
    await playerController.extractWaveformData(path: file!.path, noOfSamples: playerWaveStyle.getSamplesForWidth(200)).then((waveformData) => debugPrint(waveformData.toString()));
  }

  bool neededRealoadData = false;

  ///Mettere quì il codice di inite degli XFilters
  void initXFilters() {
    xFilter_XFilters.clear();
    xFilter_OrderBy_XProps.clear();
    xFilter_SearchBarXCols.clear();
  }

  @override
  void dispose() {
    _isLoaded.dispose();
    isBusy.dispose();
    searchController.dispose();
    if (_swipingAnimationController != null) {
      _swipingAnimationController!.dispose();
      _swipingAnimationController = null;
    }
    super.dispose();
  }

  _xFilter_build() {
    final GlobalKey<PopupMenuButtonState> _popUpMenuKey = GlobalKey<PopupMenuButtonState>();
    if (xFilter_XFilters.isEmpty) return Container();
    return InkWell(
        onTap: () => _popUpMenuKey.currentState!.showButtonMenu(),
        child: Row(
          children: [
            /// LABELS    /// LABELS /// LABELS    /// LABELS /// LABELS    /// LABELS
            xFilter_XFilters.length == 1
                // SINGOLO
                ? Container()
                // MULTI XFILTER
                : Container(
                    width: 170,
                    child: Column(children: [
                      Wrap(
                        children: xFilter_XFilters
                            .map((e) => Container(
                                  width: 170,
                                  child: Row(
                                    children: [
                                      Text(
                                        e.xPropOfItemToFilter.col_Label,
                                        style: XStyles.xStyTextForSubDescr(e.xPropOfItemToFilter.col_Color == Colors.black ? XColors.foregroundLight : e.xPropOfItemToFilter.col_Color),
                                      ),
                                      SizedBox(width: 10),
                                      Expanded(
                                          child: Container(
                                              padding: EdgeInsets.symmetric(horizontal: 4),
                                              color: (e.Value is XEnumDef ? (e.Value as XEnumDef).backColor : null),
                                              child: Text(
                                                XfxUtils.xddValueToString(e.Value, e.ColsOfXFdataItemToShow),
                                                style: XStyles.xStyTextForSubDescr((e.Value is XEnumDef ? (e.Value as XEnumDef).textColor : XColors.foregroundLight)),
                                              ))),
                                    ],
                                  ),
                                ))
                            .toList(),
                      )
                    ]),
                  ),
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            // UI XFILTER con VALUE
            xFilter_XFilters.length == 1
                // SINGOLO XFILTER
                ? Container(
                    width: 170,
                    child: XfxDropDown<dynamic>(xFilter_XFilters.first.ColsOfXFdataItemToShow,
                        label: "",
                        liItems: xFilter_XFilters.first.Items,
                        itemSelected: xFilter_XFilters.first.Value,
                        background_Color: (value) => xFilter_XFilters.first.xPropOfItemToFilter.col_Color,
                        label_Behavior: FloatingLabelBehavior.auto,
                        clearBTN_Active: xFilter_XFilters.first.All != null && xFilter_XFilters.first.Value != xFilter_XFilters.first.All,
                        onChanged_ItemOfDD: (value) {
                          setState(() {
                            xFilter_XFilters.first.Value = value == null ? xFilter_XFilters.first.All : value;
                            print(xFilter_XFilters.first.Value);
                          });
                        }))
                //MULTI XFILTER
                : Container(
                    width: 40,
                    child: PopupMenuButton(
                      key: _popUpMenuKey,
                      icon: Icon(Icons.filter_alt_outlined),
                      itemBuilder: (context) {
                        return xFilter_XFilters.map((e) => xFilter_Builder_XFilterEl(e)).toList();
                      },
                    ))
          ],
        ));
  }

  PopupMenuItem xFilter_Builder_XFilterEl(XFilterEl<dynamic> xf) {
    return PopupMenuItem(
        child: Row(children: [
      Container(
          width: 240,
          child: XfxDropDown<dynamic>(xf.ColsOfXFdataItemToShow,
              label: "",
              liItems: xf.Items,
              itemSelected: xf.Value,
              background_Color: (value) => xf.xPropOfItemToFilter.col_Color,
              label_Behavior: FloatingLabelBehavior.auto,
              clearBTN_Active: xf.All != null,
              clearBTN_getValueForCLEAR: () => xf.All,
              onChanged_ItemOfDD: (value) {
                setState(() {
                  xf.Value = value == null ? xf.All : value;
                  print(xf.Value);
                });
              }))
    ]));
  }

  bool _xFilter_FilterItem(K item) {
    // widget.whereMethod!(element, filterCurrent)
    var rval = true;
    // se ci sono appli XFilterEl
    if (xFilter_XFilters.isNotEmpty) {
      for (var xf in xFilter_XFilters) {
        var propNameReal = xf.xPropOfItemToFilter.col_Name;
        if (propNameReal.endsWith("ID")) propNameReal += "_resolved";

        if (xf.Value == xf.All)
          rval = true;
        else if (xf.Value is XFDataItem) {
          if (xf.xPropOfItemToFilter.col_Name.endsWith("ID"))
            rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XFDataItem).id;
          else
            rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XFDataItem)[xf.ColsOfXFdataItemToShow.first.col_Name];
        } else if (xf.Value is XEnumDef) {
          rval = item[xf.xPropOfItemToFilter.col_Name]! == (xf.Value as XEnumDef).value;
        } else {
          rval = item[propNameReal]! == xf.Value!;
        }
        if (!rval) return false;
      }
    }
    if (filterCurrent.isNotEmpty && xFilter_SearchBarXCols.isNotEmpty) {
      var searchBarResult = false;
      for (XProp pippo in xFilter_SearchBarXCols) {
        var propNameReal = pippo.col_Name;
        if (propNameReal.endsWith("ID")) propNameReal += "_resolved";

        searchBarResult = item[propNameReal]!.toLowerCase().contains(filterCurrent.toLowerCase());
        if (searchBarResult) {
          break;
        }
      }
      if (searchBarResult) return searchBarResult;

      if (widget.searchBar_whereMethod != null) return widget.searchBar_whereMethod!(item, filterCurrent);
      return searchBarResult;
    }
    return true;
  }

  void rebuildAllChildren(BuildContext context) {
    void rebuild(Element el) {
      el.markNeedsBuild();
      el.visitChildren(rebuild);
    }

    (context as Element).visitChildren(rebuild);
  }

  timerSearchHandlerList() {
    setState(() {
      if (timerSearch != null) timerSearch!.cancel();
      if (filterValue != "") {
        filterCurrent = filterValue.toString();
      } else if (filterValue == "") {
        filterCurrent = "";
      }
    });
  }

  xLoadDataOnly() {
    setState(() {
      isBusy.value = false;
    });
    if (xLoadData_get != null) {
      list.clear();
      list.addAll(xLoadData_get!());
      setState(() {
        isBusy.value = true;
        xAfter_LoadData_Done();
      });
    }
    if (xLoadData_apiCall != null) {
      xLoadData_apiCall!().then((value) {
        list.clear();
        list.addAll(value);
      }).whenComplete(() {
        setState(() {
          isBusy.value = true;
          xAfter_LoadData_Done();
        });
      });
    }
    neededRealoadData = false;
  }

  xAfter_LoadData_Done() {}

  List<Widget> xLayout_WidgetsLeftArea_Item(K item, void Function(void Function()) parentSetState) {
    return widget.liWidgets_LeftArea_Item != null ? widget.liWidgets_LeftArea_Item!(item)! : [];
  }

  List<Widget> xLayout_WidgetsRightArea_Item(K item, void Function(void Function()) parentSetState) {
    return widget.liWidgets_LeftArea_Item != null ? widget.liWidgets_LeftArea_Item!(item)! : [];
  }

  xOnTapItem(K item) async {
    return null;
  }

  Future<XFDataItem?> xLayout_DialogAddItem(XView xView, XFDataItem item, void Function(void Function()) setState, {List<ScontiBTN>? liSconti}) async {
    bool isFirst = false;
    int u = 0;

    XFDataItem? rval = null;
    if (xView.cols.where((e) => e.dataType != bool || e.readOnly != true || e.colKey.startsWith("li").not()).length == 1) {
      isFirst = false;
    } else {
      for (var i in xView.cols) {
        if (i.dataType == bool || i.readOnly == true || i.colKey.startsWith("li")) {
          continue;
        }
        u++;
        var x = await xEditDialog(item, i.colCaption, item[i.colKey], i, liSconti: liSconti);
        if (x == null) {
          if (u == 1) {
            isFirst = true;
          }
          break;
        } else {
          item[i.colKey] = x;
        }
      }
    }

    if (!isFirst) {
      rval = await xPreview_Dialog(xView, item);
      if (rval == null) {
        return null;
      }
    }

    return rval;
  }

  Future<dynamic> xEditDialog(XFDataItem item, String title, dynamic value, XCol xCol, {List<ScontiBTN>? liSconti}) async {
    FocusScope.of(context).unfocus();
    TextEditingController textController = TextEditingController(text: item[xCol.colKey].runtimeType != DateTime ? item[xCol.colKey].toString() : XUtils.dateToString(item[xCol.colKey], format: "dd/MM/yyyy", noDateLabel: ""));
    var res = await showDialog<dynamic>(
        context: context,
        barrierDismissible: false,
        builder: (context) {
          return StatefulBuilder(
            builder: (context, setState) {
              return Container(
                  width: MediaQuery.of(context).size.width - 10,
                  alignment: Alignment.center,
                  child: SingleChildScrollView(
                      child: XAlertDialog(
                          colorBackGround: XSchedaState.color_BackGround_EditDialog,
                          actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                          content_insetPadding: EdgeInsets.all(2),
                          height: null,
                          title_Text: title,
                          title_Style: XStyles.xStyTextForLabel(Colors.blue),
                          btnYES_label: "OK",
                          btnNO_label: "Annulla",
                          btnNO_OnPressed: () {
                            Navigator.pop(context, null);
                          },
                          btnYES_OnPressed: () {
                            if (value != textController.text) {}

                            if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
                              value = textController.text;
                            } else if (xCol.dataType == DateTime) {
                              // var t = textController.text.split("/");
                              value = DateTime.parse(textController.text);
                            } else if (xCol.dataType == double) {
                              value = double.parse(textController.text);
                            } else if (xCol.dataType == int) {
                              value = int.parse(textController.text);
                            }

                            // lo fa già xOnXCell_Edit_SubmitValue
                            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                            Navigator.pop(context, value);
                          },
                          child: xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: item) != null
                              ? xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: item)
                              : (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != DateTime && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                  ? Container()
                                  : Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
                                      SizedBox(height: 10),
                                      (xCol.dataType == String && xCol.colKey.startsWith("li").not() && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                              Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                              SizedBox(width: 10),
                                              builderXEditDialog_BTNs(item, textController, "C", false, setState),
                                            ])
                                          : xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                              ? Column(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                  Row(children: [Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController))]),
                                                  SizedBox(height: 10),
                                                  Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                                                    XBtnbase(
                                                      width: 60,
                                                      label: "Copia \nTutto",
                                                      label_TextAlign: TextAlign.center,
                                                      label_Color: Colors.white,
                                                      padding: EdgeInsets.all(0),
                                                      backGroundColor: Colors.grey[700],
                                                      onPressed: () {
                                                        Clipboard.setData(ClipboardData(text: textController.text));
                                                        ScaffoldMessenger.of(context).showSnackBar(
                                                          SnackBar(content: Text('Testo copiato negli appunti')),
                                                        );
                                                      },
                                                    ),
                                                    SizedBox(width: 20),
                                                    builderXEditDialog_BTNs(item, textController, "C", false, setState),
                                                  ])
                                                ])
                                              : xCol.dataType == DateTime
                                                  ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                      Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                                    ])
                                                  : Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                      Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                                      SizedBox(width: 10),
                                                      builderXEditDialog_BTNs(item, textController, "C", false, setState),
                                                    ]),
                                      SizedBox(height: 10),
                                      ((xCol.dataType == String).not() && xCol.dataType != DateTime)
                                          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                              Expanded(
                                                  child: Wrap(alignment: WrapAlignment.end, spacing: 8, runSpacing: 8, children: [
                                                builderXEditDialog_BTNs(item, textController, "+20", false, setState, xCol: xCol),
                                                builderXEditDialog_BTNs(item, textController, "+10", false, setState, xCol: xCol),
                                                builderXEditDialog_BTNs(item, textController, "+5", false, setState, xCol: xCol),
                                                builderXEditDialog_BTNs(item, textController, "+3", false, setState, xCol: xCol),
                                                xCol.dataType == String && xCol.colKey.startsWith("li").not() ? Container() : builderXEditDialog_BTNs(item, textController, "+1", false, setState, xCol: xCol),
                                              ]))
                                            ])
                                          : Container(),
                                    ]))));
            },
          );
        });
    return res;
  }

//CellBuilder dellxEntry
  Container xEditDialog_CellBuilder(XFDataItem item, XCol xCol, BuildContext context, void Function(void Function()) setState, TextEditingController controller, {TextInputType? keyboardType, bool autoFocus = true, bool label_Visible = false, List<TextInputFormatter>? inputFormatters}) {
    Widget _widgetForCell = Container();
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        xCol: xCol,
        autoFocus: autoFocus,
        controller: controller,
        label_Visible: label_Visible,
        multiLines: xCol.multilines,
        maxLines: xCol.multilines ? 4 : 1,
        inputFormatters: inputFormatters,
        editable: xCol.readOnly,
        keyboardType: keyboardType,
        borderColor: cell_borderColor,
        borderColor_Disabled: cell_borderColor_Disabled,
        labelColor_Disabled: cell_labelColor_Disabled,
        onSubmitted: (p0) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, p0);
        },
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        // value: item ?? "",
        onChanged: (value) {
          item[xCol.colKey] = value;
          // xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value, setState);
          // xOnXCell_Edit_OnChanged(item, xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      DateTime? dt;
      if (controller.text != "") {
        // var t = controller.text.split("-");
        dt = DateTime.parse(controller.text); //t[2].split(" ")
      }
      // var t = controller.text.split("-");
      // var dt = DateTime.parse(t[0].split(" ")[0] + "-" + t[1] + "-" + t[2]);
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          onBefore_Edit: () {},
          // controller: controller,
          value: dt == DateTime(1900, 01, 01) ? null : dt,
          onDateSelected: (value) {
            // setState(() {
            //   btnUpdateChangesShow = true;
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
            //});
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      // if (controller.text == "0.0") {
      //   controller.text = "1.0";
      // }
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          label_Visible: label_Visible,
          maxLines: 1,
          borderColor: cell_borderColor,
          borderColor_Disabled: cell_borderColor_Disabled,
          labelColor_Disabled: cell_labelColor_Disabled,
          autoFocus: true,
          onBefore_Edit: () {
            // xOnBefore_Edit(xCol, item);
          },
          keyboardType: TextInputType.number,
          controller: controller,
          // value: controller.text == "0.0" ? "" : double.parse(controller.text).toString(),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value));
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        label_Visible: label_Visible,
        autoFocus: true,
        xCol: xCol,
        borderColor: cell_borderColor,
        borderColor_Disabled: cell_borderColor_Disabled,
        labelColor_Disabled: cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        controller: controller,
        // value: controller.text == "0.0" ? "" : controller.text,
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(item, xCol, 0);
          }
        },
      );
    } else {
      return Container(width: 0, height: 0);
    }

    return Container(
      child: StatefulBuilder(builder: (context, setState) {
        return _widgetForCell;
      }),
    );
    //}
  }

  ///Da overridare per sovrascrivere il Widget all'interno dell'EdiDialog
  Widget? xEditDialog_Override_Editor(String title, dynamic value, XCol<dynamic> xCol, TextEditingController controller, {dynamic item}) {
    return null;
  }

//Builder dei bottoni cher verranno visualizzati nell'XEditDialog
  XBtnbase builderXEditDialog_BTNs(XFDataItem item, TextEditingController controller, String valueAndLabel, bool isSconto, void Function(void Function()) parentSetState, {XCol? xCol}) {
    return XBtnbase(
        padding: EdgeInsets.all(1),
        width: 45 * XUtils.kforScale,
        label_Style: XStyles.xStyTextForSubLabel(valueAndLabel.contains("+")
            ? Colors.green
            : valueAndLabel.contains("-") || valueAndLabel == ("C")
                ? Colors.red
                : Colors.green),
        label: valueAndLabel,
        backGroundColor: Colors.grey[700],
        onPressed: () {
          if (valueAndLabel == "C") {
            controller.text = "";
            FocusScope.of(context).unfocus();
          } else {
            // if (isSconto) {
            //   parentSetState(() {
            //     controller.text += calcSconto(controller, valueAndLabel);
            //   });
            // } else {
            //   if (valueAndLabel.contains("-")) {
            //     calcCell_Negative(xCol!, controller, int.parse(valueAndLabel.replaceFirst("-", "")));
            //   } else {
            //     calcCell_Positive(xCol!, controller, int.parse(valueAndLabel.replaceFirst("+", "")));
            //   }
            // }
            // controller.selection = TextSelection(baseOffset: controller.text.length, extentOffset: controller.text.length);
          }
        });
  }

  Widget? xLayout_DettItemWidget(dynamic item) {
    if (widget.liDettsSubArea_Widgets != null) {
      return widget.liDettsSubArea_Widgets!(item);
    } else {
      return null;
    }
  }

  Widget xLayout_CheckBox_Widget(bool value, XCol xCol) {
    return Checkbox(
        value: value,
        onChanged: (value) {
          setState(() {
            value = value;
            widget.edited!.value = true;
            widget.onEditBoolValueOnItem!(xCol, value ?? false);
          });
        });
  }

  Future xOnLongTapItem(dynamic item) async {
    return (widget.onLongTapItem != null) ? (widget.onLongTapItem!(item)) : null;
  }

  Future<bool> xCMD_DeleteFromList(XFDataItem itemToRemove, String title, {required Function(String) cmd_Delete}) async {
    bool x = await showDialog(
        barrierDismissible: false,
        context: context,
        builder: (builder) {
          return XAlertDialog(
            btnNO_label: "NO",
            btnYES_label: "SI",
            btnYES_OnPressed: () => Navigator.pop(context, true),
            btnNO_OnPressed: () => Navigator.pop(context, false),
            title_Text: title,
            title_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
          );
        });

    if (x) {
      // var res;
      // if (list.isNotEmpty || (widget.liDetts != null && widget.liDetts!.isNotEmpty)) {
      //   if (widget.liDetts != null) {
      //     res = widget.liDetts!.firstWhereOrNull((element) => element.id == itemToRemove.id);
      //   } else {
      //     res = list.firstWhereOrNull((element) => element.id == itemToRemove.id);
      //   }
      // }
      // (widget.rootItemEdited ?? widget.itemEdited!)(res);
      widget.edited!.value = true;
      if (itemToRemove.id == "") {
        return false;
      } else {
        if (widget.liDetts != null) {
          setState(() {
            widget.liDetts!.remove(itemToRemove);
          });
        } else {
          setState(() {
            list.remove(itemToRemove);
          });
        }
        await cmd_Delete(itemToRemove.id);

        return true;
      }
    } else {
      return false;
    }
  }

  Future<bool?> xCMD_DeleteXItem(XFDataItem itemToRemove, String title, {required Function(XFDataItem) cmd_Delete}) async {
    bool? x = await showDialog<bool?>(
        barrierDismissible: false,
        context: context,
        builder: (builder) {
          return XAlertDialog(
            btnNO_label: "NO",
            btnYES_label: "SI",
            btnYES_OnPressed: () {
              cmd_Delete(itemToRemove);
              Navigator.pop(context, true);
            },
            btnNO_OnPressed: () => Navigator.pop(context, false),
            title_Text: title,
            title_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
          );
        });
    return x;
  }

//TextFormField Editor Generico da Usare
  Widget xSch_TextFormField_Builder<T>({
    required BuildContext context,
    required XCol xCol,
    Function(String)? onChanged,
    Function(String)? onSubmitted,
    String? hintText,
    List<TextInputFormatter>? inputFormatters,
    TextInputType? keyboardType,
    bool editable = true,
    bool label_Visible = true,
    bool autoFocus = false,
    String? value,
    bool? selectText,
    bool? multiLines,
    double? height,
    int? maxLines,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Color? backgorundColor,
    Color? backgorundColor_Disabled,
    TextEditingController? controller,
    Function()? onBefore_Edit,
  }) {
    OutlineInputBorder o = OutlineInputBorder(
        borderSide: BorderSide(color: editable.not() ? (borderColor_Active ? (xCol.xmodelXprop.col_Color == Colors.black ? (borderColor ?? Colors.grey[400]!) : xCol.xmodelXprop.col_Color) : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[400]!), width: 1));
    return XTextFormField(
      controller: value != null ? null : controller,
      border: o,
      disabledBorder: o,
      enabledBorder: o,
      // byRick: label: label_Visible ? (xCol.colCaption + (xCol.format == "C" ? " €" : "")) : "",
      label: label_Visible ? xCol.colCaption + (editable ? "🔒" : "") : "",
      onChanged: onChanged,
      onFieldSubmitted: (value) {
        onSubmitted == null ? null : onSubmitted(value!);
      },
      autoFocus: autoFocus,
      onTap: () {
        if (controller != null) {
          if (xCol.dataType == String) {
          } else {
            controller.selection = TextSelection(baseOffset: 0, extentOffset: controller.text.length);
          }
        }
        onBefore_Edit!();
      },
      initialValue: controller != null ? null : value,
      // borderVisible: editable.not(),
      maxLines: maxLines,
      isCollapsed: false,
      enabled: editable.not(),
      height: null,
      fillColor: editable ? Colors.transparent : XSchedaState.color_CellBackGorundDisabled,
      filled: XSchedaState.color_CellBackGorundDisabled != null ? true : false,
      multiLines: (xCol.colCaption.toLowerCase().contains("email") || (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")) || xCol.colCaption.toLowerCase().contains("inidrizzo") || xCol.colCaption.toLowerCase().contains("ind"))
          ? false
          : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
              ? false
              : multiLines ?? false,
      contentPadding: EdgeInsets.only(top: 7, left: 5, bottom: 7),
      textStyle: XStyles.xStyleText(colorText: XSchedaState.color_Text),
      textAlign: xCol.dataType is int || xCol.dataType is double ? TextAlign.end : TextAlign.start,
      labelStyle: XStyles.xStyTextForLabel(xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color), //XSchedaState.colorOfHintText
      keyboardType: keyboardType ??
          ((xCol.colCaption.toLowerCase().contains("email"))
              ? TextInputType.emailAddress
              : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
                  ? TextInputType.phone
                  : (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto"))
                      ? TextInputType.number
                      : TextInputType.text),
      textCapitalization: (xCol.dataType == String && xCol.colKey.startsWith("li").not())
          ? TextCapitalization.sentences //
          : TextCapitalization.none,
      hintText: editable ? "..." : (hintText ?? "..."),
      hintStyle: XStyles.xStyTextForSubDescr(XSchedaState.color_HintText),
      inputFormatters: inputFormatters ?? [],
    );
  }

//Text Generico da Usare
  Widget xSch_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xFormatToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(Colors.white),
      label_Style: XStyles.xStyTextForLabel(XSchedaState.color_HintText),
    );
  }

  //quando salvo ciclo per tutte le prop dell'attore e salvo le informazioni
  ///chiamato quando il valore cambia all'interno dell EDITOR della CELLA
  xOnXCell_Edit_OnChanged(XFDataItem itemInEdit, XCol xCol, dynamic newValue) async {
    xOnXCell_Edit_SubmitValue_ToItem(itemInEdit, xCol, newValue, true);
  }

  ///called in a setState
  xOnXCell_Edit_AfterSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {}
  xOnXCell_Edit_BeforeSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) async {}

  //Da chiamare per Confermare l'edit di un dato
  /// valueForRealCol = value da mettere nella col reale: es artID noi abbiamo sempre colKey = artiID_resolved, la RealCol
  xOnXCell_Edit_SubmitValue_INTERNAL(XFDataItem itemInEdit, XCol xCol, dynamic newValue, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    var valueIsChanged;
    if (newValue != null && newValue is XEnumDef)
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue.value!);
    else
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue);

    xOnXCell_Edit_BeforeSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_SubmitValue_ToItem(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_AfterSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
  }

  xOnXCell_Before_Edit(XCol xCol, dynamic value, {dynamic itemToSet}) async {
    if (xEditDialog_liProps.isEmpty) {
      xEditDialog_EditCell = xCol.colCaption;
    } else {
      for (var i in xEditDialog_liProps) {
        xEditDialog_EditCell = " " + i.col_Label;
      }
    }

    setState(() {});
    return () {};
  }

  /// only itemInEdit[xCol.colKey] = value!;
  xOnXCell_Edit_SubmitValue_ToItem(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    if (newValue is XEnumDef) {
      itemInEdit[xCol.colKey] = newValue.value;
    } else {
      // ID & _resolved
      if (xCol.colKey.endsWith("_resolved")) {
        if (valueForResolved != null) {
          itemInEdit[xCol.colKey] = valueForResolved!;
        }
        if (valueForRealCol != null) // parte del campo vero, senza _resolved
        {
          itemInEdit[xCol.colKey.replaceAll("_resolved", "")] = valueForRealCol!;
        } else {
          itemInEdit[xCol.colKey] = newValue;
        }
      } else {
        itemInEdit[xCol.colKey] = valueForRealCol ?? newValue;
      }
    }
  }

//DateTime Editor Generico da Usare
  Widget xSch_DateFormField_Builder({
    required XCol xCol,
    required Function(DateTime)? onDateSelected,
    bool editable = true,
    DateTime? value,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Function()? onBefore_Edit,
    TextEditingController? controller,
    String? format,
  }) {
    OutlineInputBorder o = OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (borderColor_Active ? xCol.xmodelXprop.col_Color : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[800]!), width: 1));
    return DateTimeFormField(
        decoration: InputDecoration(
          contentPadding: EdgeInsets.only(right: 2, top: 2, bottom: 2, left: 4),
          hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.color_HintText),
          errorStyle: TextStyle(color: Colors.redAccent),
          border: o,
          disabledBorder: o,
          enabledBorder: o,
          labelText: xCol.colCaption,
          constraints: BoxConstraints(maxHeight: 40),
          labelStyle: value != null
              ? XStyles.xStyTextForLabel(xCol.readOnly ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[900]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)) //
              : XStyles.xStyTextForDescr(editable.not() ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight)),
        ),
        enabled: xCol.readOnly.not(),
        initialValue: value,
        dateFormat: DateFormat(format ?? "dd/MM/yy"),
        dateTextStyle: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
        initialEntryMode: DatePickerEntryMode.calendar,
        initialDatePickerMode: DatePickerMode.day,
        mode: DateTimeFieldPickerMode.date,
        autovalidateMode: AutovalidateMode.onUserInteraction,
        validator: (e) => (e?.day ?? 0) == 1 ? 'Perfavore sistema la data' : null,
        onDateSelected: (value) => onDateSelected!(value));
  }

  // @override
  // xOnXCell_Edit_OnChanged(XFDataItem itemInEdit, XCol xCol, dynamic newValue) async {
  //   if (newValue != null) setState(() => itemInEdit[xCol.colKey] = newValue);
  // }

//Preview dell'aggiunta di un nuovo Item
  Future<XFDataItem?> xPreview_Dialog(XView xView, dynamic value) async {
    dynamic valueUI = value.getCloneFull();
    var liCols = xView.cols.where((element) => element.colKey.startsWith("li").not() && element.dataType != bool && element.readOnly == false);
    return await showDialog<XFDataItem>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                width: MediaQuery.of(context).size.width - 20,
                alignment: Alignment.center,
                child: SingleChildScrollView(
                    child: XAlertDialog(
                  actionsBTNarea_Padding: EdgeInsets.all(0),
                  content_insetPadding: EdgeInsets.all(3),
                  colorBackGround: XSchedaState.color_BackGround_EditDialog,
                  btnNO_label: "Annulla",
                  btnYES_label: "Conferma",
                  btnYES_OnPressed: () {
                    xView.cols.forEach((e) {
                      if (valueUI[e.colKey] != null) setState(() => value[e.colKey] = valueUI[e.colKey]);
                      // TextEditingController controller = TextEditingController(text: value[e.colKey].toString());
                      // if (e.colKey.startsWith("li").not() && e.dataType != bool && e.readOnly == false) {
                      //   value[e.colKey] = valueUI[e.colKey];
                      // }
                    });
                    return Navigator.pop(context, valueUI);
                  },
                  btnNO_OnPressed: () {
                    return Navigator.pop(context, null);
                  },
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    mainAxisSize: MainAxisSize.min,
                    children: liCols.length == 1
                        ? [Container(width: 500, margin: EdgeInsets.symmetric(vertical: 5, horizontal: 10), child: xLayout_CellWidget_Editable(liCols.first, valueUI, context, valueUI, onBeforeCMD_Active: false))]
                        : liCols.map((e) {
                            return Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 10), child: xLayout_CellWidget_Editable(e, valueUI, context, valueUI, onBeforeCMD_Active: false));
                          }).toList(),
                  ),
                )));
          });
        });
  }

  ///BUILDER DEI WIDGET EDITABILI///
  Container xLayout_CellWidget_Editable(XCol xCol, dynamic item, BuildContext context, dynamic itemToSet, {double? fixWidth, bool onBeforeCMD_Active = true, TextEditingController? controller}) {
    late Widget _widgetForCell;
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != bool) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        controller: controller,
        xCol: xCol,
        multiLines: (fixWidth ?? xCol.width) >= 200 ? true : false,
        editable: xCol.readOnly,
        borderColor: cell_borderColor,
        borderColor_Disabled: cell_borderColor_Disabled,
        labelColor_Disabled: cell_labelColor_Disabled,
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        onBefore_Edit: () {
          if (onBeforeCMD_Active) {
            xOnXCell_Before_Edit(xCol, item[xCol.colKey], itemToSet: itemToSet);
          }
        },
        value: item[xCol.colKey] ?? "",
        onChanged: (value) {
          xOnXCell_Edit_OnChanged(item, xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          borderColor: cell_borderColor,
          borderColor_Disabled: cell_borderColor_Disabled,
          labelColor_Disabled: cell_labelColor_Disabled,
          format: xFormat_Date,
          onBefore_Edit: () => xOnXCell_Before_Edit(xCol, item),
          value: item[xCol.colKey] == DateTime(1900, 01, 01) ? null : item[xCol.colKey],
          onDateSelected: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          controller: controller,
          maxLines: 1,
          borderColor: cell_borderColor,
          borderColor_Disabled: cell_borderColor_Disabled,
          labelColor_Disabled: cell_labelColor_Disabled,
          onBefore_Edit: () {
            if (onBeforeCMD_Active) {
              xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
            }
          },
          keyboardType: TextInputType.number,
          value: (item[xCol.colKey] == null || item[xCol.colKey].toString() == "0.0") ? "" : XUtils.xFormatDouble(context, item[xCol.colKey]),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value));
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        controller: controller,
        xCol: xCol,
        borderColor: cell_borderColor,
        borderColor_Disabled: cell_borderColor_Disabled,
        labelColor_Disabled: cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          if (onBeforeCMD_Active) {
            xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
          }
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        value: item[xCol.colKey].toString() == "0.0" ? "" : XUtils.xFormatInt(context, item[xCol.colKey]),
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(item, xCol, 0);
          }
        },
      );
    } else if (xCol.dataType == bool) {
      _widgetForCell = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            activeColor: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            checkColor: XColors.foregroundDark,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                // editedPage.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else {
      //DEVE essere W e H = 0 se no il Wrap fa casino nel gestirlo e va a "un po' a capo" dopo l'ultimo Widget
      return Container(width: 0, height: 0);
    }
    return Container(
      width: fixWidth ?? xCol.width,
      padding: xCol.dataType == DateTime ? EdgeInsets.only(top: 1 * (XUtils.kforScale)) : null,
      child: _widgetForCell,
    );
    //}
  }

  Widget? xLayout_ItemWidget(K item) {
    late List<XFDataItem> liDettsUI;
    if (widget.xDett_xColname != null) {
      liDettsUI = item[widget.xDett_xColname!];
    }
    return widget.schedaMode == true
        ? XElencoItem(item, widget.view!,
            funct: widget.rootItemEdited != null ? () => widget.rootItemEdited!(item) : null,
            showingDetails: item.isShowDetails,
            margin: EdgeInsets.symmetric(vertical: 2),
            liXActions: widget.liXActions!.where((element) => element.fastAction!.not()).toList(),
            backGroundColor_ChildMain: (item.isShowDetails && widget.elDettsMode_SchItem == true ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
            backGroundColor_ChildDetails: (item.isShowDetails ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
            onDoubleTapItem: widget.onDoubleTapItem,
            showTrailingArrow: false,
            widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
            widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
            onTapItem: () async {
              var x = await xOnTapItem(item);
              if (x == null) {}

              widget.onTapItem != null ? () => widget.onTapItem!(item) : null;
            },
            onLongTapItem: () => xOnLongTapItem(item),
            xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),
            edited: widget.edited!,
            //Widget che raffigura i dettagli che sono dentro la riga espansa
            childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.liDettsSubArea_Widgets != null ? widget.liDettsSubArea_Widgets!(item) ?? Container() : Container())]))
        : (widget.elDettsMode_SchItem != null && widget.elDettsMode_SchItem!)
            ? xLayout_DettItemWidget(item) ??
                XElencoItem(item, widget.view!,
                    funct: widget.rootItemEdited != null ? () => widget.rootItemEdited!(item) : null,
                    showingDetails: item.isShowDetails,
                    liXActions: widget.liXActions!.where((element) => element.fastAction!.not()).toList(),
                    margin: EdgeInsets.symmetric(vertical: 2),
                    backGroundColor_ChildMain: widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30)),
                    backGroundColor_ChildDetails: widget.xDettItem_BackGroundColor ?? (widget.appBar_Color == null ? widget.xDettItem_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30)),
                    onDoubleTapItem: widget.onDoubleTapItem,
                    widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
                    widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                    showTrailingArrow: true,
                    xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),
                    //DD 19/09/23 questo ha risolto su ELattACQ che NON espandeva i datt, magari ha portato altri casini
                    onTapItem: () async {
                      setState(() {
                        item.isSel = item.isShowDetails = item.isShowDetails.not();
                      });

                      await xOnTapItem(item);
                      widget.onTapItem != null ? () => widget.onTapItem!(item) : null;
                    },
                    onLongTapItem: () => xOnLongTapItem(item),
                    edited: widget.edited!,
                    childDetails: Container(
                        width: MediaQuery.of(context).size.width,
                        child: widget.showHead_DettsRowInItem && widget.xDett_xColname != null
                            ? XScheda(item, widget.viewDetts!, showHead: widget.showHead_DettsRowInItem, modePage_Active: false)
                            : Container(
                                child: Column(
                                crossAxisAlignment: CrossAxisAlignment.start,
                                children: liDettsUI
                                    .map((element) => Container(
                                        child: Column(
                                            crossAxisAlignment: CrossAxisAlignment.start,
                                            children: widget.viewDetts!.cols.groupListsBy((element) => element.originY).entries.map((e) {
                                              return Wrap(
                                                  spacing: 3,
                                                  runSpacing: 5,
                                                  children: e.value.map((e) {
                                                    return xLayout_Item_RowWidgets(e, element);
                                                  }).toList());
                                            }).toList())))
                                    .toList(),
                              ))))
            : xLayout_DettItemWidget(item) ??
                XElencoItem(item, widget.view!,
                    funct: widget.rootItemEdited != null ? () => widget.rootItemEdited!(item) : null,
                    showingDetails: item.isShowDetails,
                    liXActions: widget.liXActions!.where((element) => element.fastAction!.not()).toList(),
                    margin: EdgeInsets.symmetric(vertical: 2),
                    backGroundColor_ChildMain: (item.isShowDetails && widget.elDettsMode_SchItem == true ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
                    backGroundColor_ChildDetails: (item.isShowDetails ? Colors.grey[900] : widget.itemSelected_BackGroundColor ?? (widget.appBar_Color == null ? widget.itemSelected_BackGroundColor ?? Colors.grey[900] : widget.appBar_Color!.withAlpha(30))),
                    onDoubleTapItem: widget.onDoubleTapItem,
                    edited: widget.edited!,
                    showTrailingArrow: false,
                    widgets_RightArea: xLayout_WidgetsRightArea_Item(item, setState),
                    widgets_LeftArea: xLayout_WidgetsLeftArea_Item(item, setState),
                    onLongTapItem: () => xOnLongTapItem(item),
                    onTapItem: () async {
                      await xOnTapItem(item);
                      if (widget.onTapItem != null) {
                        widget.onTapItem!(item);
                      }
                      (widget.schNameToOpen != null && widget.schedaMode == false
                          ? Navigator.pushNamed(context, widget.schNameToOpen!, arguments: item).then((value) {
                              setState(() {
                                isBusy.value = true;
                                widget.xOnReturnBack != null ? widget.xOnReturnBack!(setState) : null;
                                widget.edited!.value;
                              });

                              rebuildAllChildren(context);
                            }) //
                          : setState(() => item.isShowDetails = item.isShowDetails.not()));
                    },
                    xLayout_Item_RowWidgets: (xCol, item) => xLayout_Item_RowWidgets(xCol, item),

                    //Widget che raffigura la riga che si espande
                    // childMain: Container(
                    //     decoration: item.isShowDetails ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                    //     padding: EdgeInsets.symmetric(horizontal: 2, vertical: 8),
                    //     child: Row(children: [
                    //       Expanded(
                    //           child: Column(
                    //               crossAxisAlignment: CrossAxisAlignment.start,
                    //               children: widget.view!.cols.groupListsBy((element) => element.originY).entries.map((e) {
                    //                 return Wrap(
                    //                     spacing: 3,
                    //                     runSpacing: 5,
                    //                     children: e.value.map((e) {
                    //                       return xLayout_Item_RowWidgets(e, item);
                    //                     }).toList());
                    //               }).toList())),
                    //       li.isNotEmpty ? Text((widget.viewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                    //       xLayout_BTN_Function(item),
                    //       (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(item) : Container()
                    //     ])),
                    //Widget che raffigura i dettagli che sono dentro la riga espansa
                    childDetails: Column(mainAxisSize: MainAxisSize.min, children: [(widget.liDettsSubArea_Widgets != null ? widget.liDettsSubArea_Widgets!(item) ?? Container() : Container())]));
  }

  Widget xLayout_Item_RowWidgets(XCol xCol, XFDataItem item, {bool noTextWhenCellValueIsNull = true, String? formatDate}) {
    Widget _xContainerOfWidgets;
    Color xColColor = xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color;
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : ""), maxLines: xCol.multilines ? 3 : 1, style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _xContainerOfWidgets = Text(XUtils.dateToString(item[xCol.colKey] ?? DateTime(1900, 01, 01), format: formatDate ?? xFormat_Date), maxLines: 1, style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      if (xCol.format == "C") {
        _xContainerOfWidgets = Text(XUtils.xFormatToCurrency(context, item[xCol.colKey] ?? 0.0), style: XStyles.xStyTextForDescr(xColColor), textAlign: TextAlign.end, overflow: TextOverflow.fade);
        // Se è un un semplice double
      } else {
        _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0.0", style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);
      }
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0", style: XStyles.xStyTextForDescr(xColColor), overflow: TextOverflow.fade);

      //Se fosse una lista e voglio prendere la quantità di oggetti dentro
    } else if (xCol.dataType == bool) {
      _xContainerOfWidgets = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color,
            activeColor: xCol.xmodelXprop.col_Color,
            checkColor: XColors.foregroundDark,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                if (item is K)
                  widget.rootItemEdited != null ? widget.rootItemEdited!(item) : null;
                else
                  widget.itemEdited != null ? widget.itemEdited!(item) : null;

                widget.edited!.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else if (xCol.dataType == String && (xCol.colKey.startsWith("li"))) {
      _xContainerOfWidgets = Container();
    } else {
      _xContainerOfWidgets = Text(xCol.headerToolTip + (item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : "")), style: XStyles.xStyTextForDescr(Colors.white), overflow: TextOverflow.fade);
    }

    //Se la colonna è Width FLEX
    // if (xCol.resizeStyle == 0) {
    //   return Flexible(flex: (xCol.spanX == 0) ? 1 : xCol.spanX, child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _xContainerOfWidgets));
    // }
    // //Se la colonna è Width PROPORTIONAL
    // else if (xCol.resizeStyle == 1) {
    //   return Container(constraints: BoxConstraints(minWidth: xCol.minWidth, maxWidth: xCol.maxWidth), margin: EdgeInsets.symmetric(horizontal: 2), child: _xContainerOfWidgets);
    // }
    // //Se la colonna è Width FIX
    // else {
    return Container(padding: EdgeInsets.only(left: 2), alignment: Alignment.centerLeft, width: xCol.width * XUtils.kforScale, child: _xContainerOfWidgets);
    // }
  }

  Widget xLayout_Widget_IfEmptyList() {
    // var x = widget.BTNEmptyList_BL == null ? Container() : (el_OBJ, parentState) => widget.BTNEmptyList_BL!(el_OBJ, parentState);
    return Container();
  }

  Widget xLayout_AreaElenco() {
    return Container(
        margin: EdgeInsets.symmetric(horizontal: widget.margin_Horizontal ?? 0),
        child: Column(children: [
          (widget.schedaMode ?? false)
              ? Container()
              : Container(
                  decoration: BoxDecoration(
                      border: Border(
                    left: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                    right: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                    bottom: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                  )),
                  padding: EdgeInsets.only(bottom: 1),
                  child:
                      //  found.kIsWeb.not() && Platform.isAndroid && (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) && (MediaQuery.of(context).orientation == Orientation.portrait)
                      //     ? Container()
                      //     :
                      Row(children: [
                    Expanded(
                      child: widget.searchBar_Active && list.length > 10
                          ? XSearchBar(
                              marginOfSearchBox: EdgeInsets.symmetric(vertical: 2),
                              paddingOfContent: EdgeInsets.only(left: 5),
                              height: 40,
                              hintStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorHint ?? XColors.foregroundLight),
                              textStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorText ?? XColors.foregroundLight),
                              colorIconForClear: widget.searchBar_ColorIconClear ?? XColors.foregroundLight,
                              colorIconForSearch: widget.searchBar_ColorIconSearch ?? XColors.foregroundLight,
                              autoFocus: false,
                              onTextChanged: (value) {
                                setState(() {
                                  if (value == "") {
                                    searchController.text = "";
                                    filterCurrent = filterAll;
                                  } else {
                                    filterCurrent = value;
                                  }
                                });
                              },
                              onPressedClear: () {
                                setState(() {
                                  filterCurrent = filterAll;
                                  searchController.text = "";
                                });
                              },
                              border: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                              disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                              enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                              controller: searchController,
                              colorOfSearchBox: widget.searchBar_Color,
                              hintText: widget.searchBar_hintText ?? "cerca..",
                              iconForSearch: null)
                          : Container(),
                    ),
                    XBtnbase(
                      icon: widget.headers_Visible ? Icons.expand_less_outlined : Icons.expand_more_outlined,
                      backGroundColor: Colors.grey[900],
                      width: 40,
                      height: 40,
                      icon_Color: widget.headers_Visible ? Colors.amber : Colors.white,
                      onPressed: () {
                        setState(() {
                          widget.headers_Visible = widget.headers_Visible.not();
                        });
                      },
                    ),
                    widget.allowAdd ? _buildAddBTN() : Container()
                  ])),

          //RENDERIZZA L'HEADER DEL L ELENCO
          (widget.headers_Visible && widget.view!.cols.where((xcol) => xcol.colKey.startsWith("li").not()).length > 3)
              ? MediaQuery.of(context).size.height < 40
                  ? Container()
                  : Container(
                      margin: xMedia_Active ? EdgeInsets.only(left: 30) : null,
                      padding: EdgeInsets.only(top: 4),
                      decoration: BoxDecoration(
                          border: Border(
                        bottom: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                        left: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                        right: BorderSide(color: XSchedaState.color_AppBar_Background, width: 3),
                      )),
                      child: Row(children: [Expanded(child: SingleChildScrollView(child: Column(children: xLayout_Render_HeadView(widget.view!, border_Visible: widget.borderAree_Header ?? false))))]))
              : Container(),
          //RENDERIZZA L'HEADER DEL L ELENCO

          widget.title_OnTop_Visible == true
              ? Row(
                  children: [
                    Expanded(
                        child: XContainerWithLabel(
                      widget.title_Text,
                      height: widget.heightContainerElTitle,
                      color: widget.colorBackgroundContainerElTitle ?? widget.searchBar_Color ?? XColors.backGroundTitleContainerForElenco,
                      textStyle: widget.title_Style ?? XStyles.xStyTextForTextBase(XColors.foregroundDark),
                    )),
                    widget.BTNtitle_Visible == true
                        ? Container(
                            margin: widget.BTNtitle_Margin ?? EdgeInsets.only(left: 5),
                            height: widget.BTNtitle_Height ?? 25,
                            width: widget.BTNtitle_Width ?? 70,
                            child: XBtnbase(
                              label: widget.BTNtitle_Label ?? "Add New",
                              onPressed: widget.BTNtitle_OnPressed,
                              decoration: BoxDecoration(color: widget.BTNtitle_Color),
                            ),
                          )
                        : Container(),
                  ],
                )
              : Container(),
          SizedBox(height: 7),
          // SizedBox(height: widget.headers_Visible == true && widget.headers_Visible != null ? 3 : 0),
          // widget.headers_Visible == true && widget.headers_Visible != null ? Row(children: widget.headers!) : Container(),
          // SizedBox(height: widget.headers_Visible == true && widget.headers_Visible != null ? 5 : 0),
          // widget.filters_Visible == true && widget.filters_Visible != null ? Row(children: widget.filters!) : Container(),
          // SizedBox(height: widget.filters_Visible == true && widget.filters_Visible != null ? 5 : 0),
          ///Da overridare per aggiungere un tuo widget nell'elenco solo se la lista è vuota
          SizedBox(height: 7),
          Expanded(
              flex: widget.flexForList ?? 18,
              child: ((widget.schedaMode ?? false) && widget.onRefresh_ScrollDownList != null)
                  ? RefreshIndicator(
                      triggerMode: RefreshIndicatorTriggerMode.anywhere,
                      onRefresh: () => widget.onRefresh_ScrollDownList!(context),
                      child: Scrollbar(
                          thumbVisibility: true,
                          controller: scroll_controller,
                          child: ListView(
                            children: (list.isEmpty && (widget.liDetts != null && widget.liDetts!.isEmpty))
                                ? [xLayout_Widget_IfEmptyList()]
                                : widget.liDetts != null
                                    ? widget.liDetts!.where((element) {
                                        //TODO
                                        // for (var xProp in xFilter_OrderBy_XProps) {
                                        //   widget.liDetts!.orderBy([xProp.col_Name], desc: (widget.view!.cols.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
                                        // }
                                        //TODO
                                        return _xFilter_FilterItem(element);
                                      }).map((e) {
                                        return widget.item_Widget != null
                                            ? widget.item_Widget!(e) ?? Container() //
                                            : xLayout_ItemWidget(e) ?? Container();
                                      }).toList()
                                    : list.where((element) {
                                        //TODO
                                        // for (var xProp in xFilter_OrderBy_XProps) {
                                        //   list.orderBy([xProp.col_Name], desc: (widget.view!.cols.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
                                        // }

                                        //TODO
                                        return _xFilter_FilterItem(element);
                                      }).map((e) {
                                        return widget.item_Widget != null
                                            ? widget.item_Widget!(e) ?? Container() //
                                            : xLayout_ItemWidget(e) ?? Container();
                                      }).toList(),
                            controller: scroll_controller,
                          )))
                  : Scrollbar(
                      thumbVisibility: true,
                      controller: scroll_controller,
                      child: ListView(
                        children: (list.isEmpty && (widget.liDetts != null && widget.liDetts!.isEmpty))
                            ? [xLayout_Widget_IfEmptyList()]
                            : widget.liDetts != null
                                ? widget.liDetts!.where((element) {
                                    //TODO
                                    for (var xProp in xFilter_OrderBy_XProps) {
                                      widget.liDetts!.orderBy([xProp.col_Name], desc: (widget.view!.cols.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
                                    }
                                    //TODO
                                    return _xFilter_FilterItem(element);
                                  }).map((e) {
                                    return widget.item_Widget != null
                                        ? widget.item_Widget!(e) ?? Container() //
                                        : xLayout_ItemWidget(e) ?? Container();
                                  }).toList()
                                : list.where((element) {
                                    //TODO
                                    for (var xProp in xFilter_OrderBy_XProps) {
                                      list.orderBy([xProp.col_Name], desc: (widget.view!.cols.firstWhere((element) => element.colKey == xProp.col_Name).sorted ?? false).not());
                                    }
                                    //TODO
                                    return _xFilter_FilterItem(element);
                                  }).map((e) {
                                    return widget.item_Widget != null
                                        ? widget.item_Widget!(e) ?? Container() //
                                        : xLayout_ItemWidget(e) ?? Container();
                                  }).toList(),
                        controller: scroll_controller,
                      )))
        ]));
  }

  Widget xLayout_Render_HeadView_Widget_forY(
    MapEntry<int, List<XCol<dynamic>>> e,
    List<Widget> children,
    int lastY,
    bool border_separator, {
    bool border_Visible = true,
    Color? border_color,
  }) {
    return Container(
        // padding: EdgeInsets.only(left: 5, right: 5),
        child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [
      Container(
          // padding: border_Visible ? EdgeInsets.only(bottom: 6, top: 10) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
          alignment: Alignment.topLeft,
          // margin: border_Visible ? EdgeInsets.only(top: 5, left: 5, right: 5) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
          child: Wrap(
            direction: Axis.horizontal,
            alignment: WrapAlignment.start,
            runAlignment: WrapAlignment.start,
            crossAxisAlignment: WrapCrossAlignment.start,
            children: children,
          ))
    ]));
  }

  xOnTapHeaderCell(XCol xCol) {
    setState(() {
      widget.view!.cols.forEach((element) {
        if (element.colKey != xCol.colKey) {
          element.sorted = null;
        }
      });
      if (xCol.sorted == null) {
        xCol.sorted = true;
      } else {
        xCol.sorted = xCol.sorted!.not();
      }
      if (widget.liDetts != null) {
        widget.liDetts!.orderBy([xCol.colKey], desc: (xCol.sorted ?? false).not());
      } else {
        list.orderBy([xCol.colKey], desc: (xCol.sorted ?? false).not());
      }
    });
  }

  double xLayout_maxRowLen = 0.0;
  List<Widget> xLayout_Render_HeadView(XView xview, {bool border_Visible = true}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = widget.view!.cols
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((xCol) {
              var xwidgt = Container(
                  padding: EdgeInsets.symmetric(horizontal: 2, vertical: widget.pageMode_Active ? 2 : 5),
                  decoration: BoxDecoration(
                    color: (xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color).withAlpha(40),
                    border: Border.all(width: 1, color: xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight.withAlpha(150) : xCol.xmodelXprop.col_Color.withAlpha(150)),
                  ),
                  constraints: BoxConstraints(minWidth: xCol.width * XUtils.kforScale),
                  child: InkWell(
                      onTap: () async {
                        //Tap per gestire il sort delle colonne
                        await xOnTapHeaderCell(xCol);
                      },
                      child: Text(
                        (xCol.sorted == null
                                ? ""
                                : xCol.sorted!.not()
                                    ? " ⇧ "
                                    : " ⇩ ") +
                            xCol.colCaption,
                        style: XStyles.xStyTextForSubLabel(xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color),
                      )));
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }

  List<Widget> xLayout_Actions() {
    List<Widget> list = List<Widget>.empty(growable: true);
    list.add(_xFilter_build());
    return list;
  }

  onComeBackFromSchDett(K? item) {
    if (neededRealoadData) xLoadDataOnly();
  }

  @override
  Widget build(BuildContext context) {
    return widget.pageMode_Active
        ? Scaffold(
            appBar: widget.appBar_Visible
                ?
                // found.kIsWeb.not() && Platform.isAndroid && (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) && (MediaQuery.of(context).orientation == Orientation.portrait)
                //     ? null
                //     :
                AppBar(
                    toolbarHeight: widget.appBar_Height ?? null,
                    automaticallyImplyLeading: true,
                    leadingWidth: 200,
                    leading: InkWell(
                        splashColor: Colors.transparent,
                        enableFeedback: false,
                        onTap: () => widget.xApp!.state.scaffoldKey_MainMenu.currentState!.openDrawer(),
                        child: Container(
                            child: Row(mainAxisSize: MainAxisSize.min, children: [
                          Container(width: 40, child: Icon(Icons.arrow_back, color: widget.title_Color)),
                          Flexible(child: Text(widget.title_Text, style: widget.title_Style ?? XStyles.xStyTextForLabel(widget.title_Color ?? XColors.foregroundLight), overflow: TextOverflow.ellipsis)),
                        ]))),
                    // leading: widget.xDrawerMenu != null ? null : XBtnbase(icon: Icons.menu, onPressed: widget.onPressed_MENU, width: 40, icon_Size: 28, height: 40),
                    backgroundColor: XSchedaState.color_AppBar_Background,
                    actions: [
                        Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 5), child: Row(children: xLayout_Actions())),
                        widget.onRefresh_ScrollDownList == null
                            ? Container()
                            : XBtnbase(
                                icon: Icons.replay_outlined,
                                onPressed: widget.onRefresh_ScrollDownList != null ? () => widget.onRefresh_ScrollDownList!(context) : () {},
                                width: 40,
                                height: 40,
                                margin: EdgeInsets.all(5),
                              ),
                      ])
                : null,
            body: widget.widgetBuild_Override ??
                // Stack(children: [
                ValueListenableBuilder<bool>(
                  valueListenable: isBusy,
                  builder: (_, loaded, __) {
                    if (loaded) {
                      return
                          //  found.kIsWeb.not() && Platform.isAndroid && (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) && (MediaQuery.of(context).orientation == Orientation.portrait)
                          //     ? Container(
                          //         child: Row(children: [
                          //           Expanded(child: xLayout_AreaElenco()),
                          //           Container(
                          //               color: XSchedaState.color_AppBar_Background,
                          //               width: 200,
                          //               child: Column(
                          //                 children: [
                          //                   Row(children: [
                          //                     Expanded(
                          //                         child: InkWell(
                          //                             splashColor: Colors.transparent,
                          //                             enableFeedback: false,
                          //                             onTap: () => widget.xApp!.state.scaffoldKey_MainMenu.currentState!.openDrawer(),
                          //                             child: Container(
                          //                                 child: Row(mainAxisSize: MainAxisSize.min, children: [
                          //                               Container(width: 40, child: Icon(Icons.arrow_back, color: widget.title_Color)),
                          //                               Flexible(child: Text(widget.title_Text, style: widget.title_Style ?? XStyles.xStyTextForLabel(widget.title_Color ?? XColors.foregroundLight), overflow: TextOverflow.ellipsis)),
                          //                             ]))))
                          //                   ]),
                          //                   Row(
                          //                     children: [
                          //                       Expanded(
                          //                           child: Column(children: [
                          //                         Container(margin: EdgeInsets.symmetric(vertical: 5, horizontal: 5), child: Row(children: xLayout_Actions())),
                          //                         widget.onRefresh_ScrollDownList == null
                          //                             ? Container()
                          //                             : XBtnbase(
                          //                                 icon: Icons.replay_outlined,
                          //                                 onPressed: widget.onRefresh_ScrollDownList != null ? () => widget.onRefresh_ScrollDownList!(context) : () {},
                          //                                 width: 40,
                          //                                 height: 40,
                          //                                 margin: EdgeInsets.all(5),
                          //                               )
                          //                       ]))
                          //                     ],
                          //                   ),
                          //                   found.kIsWeb.not() && Platform.isAndroid && (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) && (MediaQuery.of(context).orientation == Orientation.portrait)
                          //                       ? Row(children: [
                          //                           Expanded(
                          //                             child: widget.searchBar_Active && list.length > 10
                          //                                 ? XSearchBar(
                          //                                     marginOfSearchBox: EdgeInsets.symmetric(vertical: 2),
                          //                                     paddingOfContent: EdgeInsets.only(left: 5),
                          //                                     height: 40,
                          //                                     hintStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorHint ?? XColors.foregroundLight),
                          //                                     textStyle: XStyles.xStyTextForSubLabel(widget.searchBar_ColorText ?? XColors.foregroundLight),
                          //                                     colorIconForClear: widget.searchBar_ColorIconClear ?? XColors.foregroundLight,
                          //                                     colorIconForSearch: widget.searchBar_ColorIconSearch ?? XColors.foregroundLight,
                          //                                     autoFocus: false,
                          //                                     onTextChanged: (value) {
                          //                                       setState(() {
                          //                                         if (value == "") {
                          //                                           searchController.text = "";
                          //                                           filterCurrent = filterAll;
                          //                                         } else {
                          //                                           filterCurrent = value;
                          //                                         }
                          //                                       });
                          //                                     },
                          //                                     onPressedClear: () {
                          //                                       setState(() {
                          //                                         filterCurrent = filterAll;
                          //                                         searchController.text = "";
                          //                                       });
                          //                                     },
                          //                                     border: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                          //                                     disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                          //                                     enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: widget.searchBar_ColorBorder ?? widget.searchBar_ColorHint ?? widget.searchBar_ColorText ?? XColors.foregroundLight)),
                          //                                     controller: searchController,
                          //                                     colorOfSearchBox: widget.searchBar_Color,
                          //                                     hintText: widget.searchBar_hintText ?? "cerca..",
                          //                                     iconForSearch: null)
                          //                                 : Container(),
                          //                           ),
                          //                           XBtnbase(
                          //                             icon: widget.headers_Visible ? Icons.expand_less_outlined : Icons.expand_more_outlined,
                          //                             backGroundColor: Colors.grey[900],
                          //                             width: 40,
                          //                             height: 40,
                          //                             icon_Color: widget.headers_Visible ? Colors.amber : Colors.white,
                          //                             onPressed: () {
                          //                               setState(() {
                          //                                 widget.headers_Visible = widget.headers_Visible.not();
                          //                               });
                          //                             },
                          //                           ),
                          //                           widget.allowAdd ? _buildAddBTN() : Container()
                          //                         ])
                          //                       : Container()
                          //                 ],
                          //               )),
                          //         ]),
                          //       )
                          // :
                          xLayout_AreaElenco();
                    } else {
                      return XStatefulWidgetBase.LoaderIndicator(isBusy.value.not(), label: waiterMessage);
                    }
                  },
                ),
            // isBusy.value ? Container(color: Colors.black.withAlpha(180)) : xLayout_AreaElenco(),
            // isBusy.value ? XStatefulWidgetBase.LoaderIndicator(isBusy.value, label: waiterMessage) : Container(),
            // ]),
            floatingActionButton: widget.floatingActionButton,
            drawer: widget.xDrawerMenu)
        : widget.widgetBuild_Override ?? xLayout_AreaElenco();
  }

  Widget _buildAddBTN() {
    return XBtnbase(
      margin: EdgeInsets.only(left: 5),
      width: 150,
      height: 40,
      // radiusBorder: 20,
      icon_WidthArea: 30,
      toolTip_Message: "Aggiungi ${widget.title_Text}",
      icon: Icons.add,
      icon_Size: 20,
      label: widget.title_Text,
      label_Style: XStyles.xStyTextForSubLabel(widget.title_Color ?? widget.searchBar_Color),
      icon_Color: widget.title_Color ?? widget.searchBar_Color,
      backGroundColor: Colors.grey[900],
      onPressed: widget.cmd_Add != null
          ? () async {
              var res = await widget.cmd_Add!(setState);
              if (res != null) {
                onComeBackFromSchDett(res);
              }
            }
          : null,
    );
  }

  Widget xActionsItem_ViewDett(XFDataItem item, bool dett_Active, void Function(void Function()) parentSetState, XView xView_Elenco, {String? title}) {
    return Container(
        child: XBtnbase(
      height: 40,
      width: 40,
      icon_WidthArea: 30,
      label_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
      icon: Icons.edit,
      icon_Size: 23,
      icon_Color: Colors.yellow,
      toolTip_Message: "Modifica questa riga",
      onPressed: () async {
        var res = await xPreview_Dialog(xView_Elenco, item);
        if (res != null) {
          item = res.getCloneFull();
          if (item is K)
            widget.rootItemEdited != null ? widget.rootItemEdited!(item as K) : null;
          else
            widget.itemEdited != null ? widget.itemEdited!(item) : null;
        }
      },
    ));
  }

  Future<bool?>? xOnDelXMedia_InPreview(XMediaItem xMedia, void Function(void Function()) setState) async {
    var res = await showDialog<bool?>(
      context: context,
      builder: (context) {
        return XAlertDialog(
          title_Text: "Sicuro di voler cancellare il Media ${xMedia.blobURL}?",
          title_Style: XStyles.xStyTextForSubLabel(XColors.warning),
          btnNO_label: "Annulla",
          btnYES_label: "Si",
          btnNO_OnPressed: () => Navigator.pop(context, false),
          btnYES_OnPressed: () => Navigator.pop(context, true),
        );
      },
    );
    if (res != null && res) {
      setState(() {
        liXMedias_MediaRecorder.value.remove(xMedia);
      });
      return res;
    } else {
      return false;
    }
  }

  bool isTakingPhoto = false;
  bool isRecording = false;
  bool saving = false;

  Future<File?> cmd_GetMedia(void Function(void Function()) setState, XFDataItem item) async {
    item.isShowDetails = true;
    FocusScope.of(context).unfocus();

    var res = await showDialog<bool?>(
        context: context,
        barrierDismissible: false,
        builder: (builder) {
          return StatefulBuilder(builder: (context, setState) {
            final global_Key = GlobalKey();
            return XAlertDialog(
                colorBackGround: Colors.grey[900],
                actionsBTNarea_Padding: EdgeInsets.all(0),
                content_VerticalPadding: 5,
                child: Container(
                    alignment: Alignment.topCenter,
                    child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        saving
                            ? Container()

                            ///Row delle Preview dei media fatti
                            : Row(mainAxisAlignment: liXMedias_MediaRecorder.value.isNotEmpty ? MainAxisAlignment.start : MainAxisAlignment.center, children: [
                                Expanded(
                                    child: SingleChildScrollView(
                                  scrollDirection: Axis.horizontal,
                                  child: Row(
                                    mainAxisAlignment: MainAxisAlignment.center,
                                    crossAxisAlignment: CrossAxisAlignment.center,
                                    children: liXMedias_MediaRecorder.value.isEmpty
                                        ? [Container(height: 80, width: MediaQuery.of(context).size.width, color: Colors.grey[800], alignment: Alignment.center)]
                                        : liXMedias_MediaRecorder.value
                                            .map((e) => InkWell(
                                                  onTap: () {
                                                    if (e.mediaType == XEnums.mediaType.image.value) {
                                                      cmd_OpenPhoto(e, item);
                                                    } else if (e.mediaType == XEnums.mediaType.video.value) {
                                                      cmd_OpenVideo(e, liXMedias_MediaRecorder.value.where((element) => element.mediaType == XEnums.mediaType.video.value).toList(), pathPreviewVideo: "${XLibStorage.filePath}/XMEDIAS/${e.id}_.mp4", setState: setState);
                                                    } else if (e.mediaType == XEnums.mediaType.audio.value) {
                                                      cmd_OpenAudio(e, item, true);
                                                    }
                                                  },
                                                  onLongPress: () async {
                                                    await xOnDelXMedia_InPreview(e, setState);
                                                  },
                                                  child: e.mediaType == XEnums.mediaType.image.value
                                                      ? Container(
                                                          width: 80,
                                                          height: 80,
                                                          child: Stack(children: [
                                                            Container(margin: EdgeInsets.symmetric(horizontal: 5), width: 80, child: Image.memory(e.payload!, width: 80, height: 80)),
                                                            e.overlaySurface != null
                                                                ? Container(
                                                                    margin: EdgeInsets.only(bottom: 50),
                                                                    child: Image.memory(
                                                                      e.overlaySurface!,
                                                                      height: 80,
                                                                      width: 80,
                                                                    ))
                                                                : Container()
                                                          ]))
                                                      : e.mediaType == XEnums.mediaType.video.value
                                                          ? Container(
                                                              margin: EdgeInsets.symmetric(horizontal: 5),
                                                              decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(e.miniatura!))),
                                                              width: 80,
                                                              height: 80,
                                                              child: Container(
                                                                child: Icon(Icons.play_arrow, size: 28, color: Colors.blueAccent[900]),
                                                              ))
                                                          : Container(
                                                              margin: EdgeInsets.symmetric(horizontal: 5),
                                                              decoration: BoxDecoration(color: Colors.grey[800]),
                                                              width: 80,
                                                              height: 80,
                                                              child: Icon(Icons.mic),
                                                            ),
                                                ))
                                            .toList(),
                                  ),
                                ))
                              ]),

                        ///XMEDIA RECORDER
                        ///XMEDIA RECORDER
                        // saving
                        //     ? XStatefulWidgetBase.LoaderIndicator(saving, label: "salvataggio Media..", fixHeight: 50, fixWidth: 50)
                        //     :
                        Container(
                            width: MediaQuery.of(context).size.width,
                            height: MediaQuery.of(context).orientation == Orientation.portrait ? MediaQuery.of(context).size.height / 1.34 : MediaQuery.of(context).size.height / 1.42,
                            child: XMediaRecorder<XFDataItem>(
                              global_Key,
                              parentSetState: setState,
                              itemOriginal: item,
                              lXMedias: liXMedias_MediaRecorder.value,
                              xApp: widget.xApp!,
                              onStartTakeVideo: (parentState) => setState(() => isRecording = true),
                              onEndTakeVideo: (parentState) => setState(() => isRecording = false),
                              onTakeMedia: (parentState) => setState(() {
                                isTakingPhoto = isTakingPhoto.not();
                              }),
                            ))

                        ///XMEDIA RECORDER
                        ///XMEDIA RECORDER
                      ],
                    )),
                title_Widget: Container(),
                title_Style: XStyles.xStyTextForLabel(Colors.yellow),
                content_insetPadding: EdgeInsets.all(0),
                actionsBTNarea_Child: Container(
                    height: 70,
                    child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                      isRecording || isTakingPhoto
                          ? Expanded(
                              child: isRecording
                                  ? Text("Sto Registrando...", style: XStyles.xStyTextForSubLabel(Colors.red), textAlign: TextAlign.center) //
                                  : isTakingPhoto.not()
                                      ? Container()
                                      : XStatefulWidgetBase.LoaderIndicator(isTakingPhoto, label: "Acquisizione Media..", fixHeight: 30, fixWidth: 30))
                          : Container(),
                      isTakingPhoto || isRecording
                          ? Container()
                          : Expanded(
                              child: XBtnbase(
                              height: 45,
                              icon_Widget: Icon(Icons.undo, color: Colors.red, size: 30),
                              backGroundColor: Colors.grey[900]!,
                              onPressed: () async {
                                liXMedias_MediaRecorder.value.clear();
                                Navigator.pop(context, false);
                              },
                              elevation: 0,
                              label: "",
                            )),
                      SizedBox(width: 1),
                      liXMedias_MediaRecorder.value.isNotEmpty
                          ? isTakingPhoto || isRecording
                              ? Container()
                              : Expanded(
                                  child: XBtnbase(
                                  height: 45,
                                  backGroundColor: Colors.grey[900]!,
                                  onPressed: () async {
                                    setState(() {
                                      saving = true;
                                    });
                                    if (liXMedias_MediaRecorder.value.isNotEmpty) {
                                      isTakingPhoto = true;
                                      await Future.forEach(liXMedias_MediaRecorder.value, (xclMedia) => xMedia_onTake_handling(xclMedia.payload!, isBusy.value, setState, item, xclMedia.mediaType!));
                                      await xOnSaveXMedia_INTERNAL(liMediaRAW, item)?.then((value) => Navigator.pop(context, true));
                                      item.showXMedia = true;
                                      if (item is K)
                                        widget.rootItemEdited != null ? widget.rootItemEdited!(item) : null;
                                      else
                                        widget.itemEdited != null ? widget.itemEdited!(item) : null;
                                    }
                                    liXMedias_MediaRecorder.value.clear();
                                    isTakingPhoto = false;
                                    setState(() {
                                      saving = false;
                                    });
                                  },
                                  elevation: 0,
                                  icon_Widget: Icon(Icons.save, color: Colors.green, size: 30),
                                  // label: "CONFERMA",
                                  label_Style: XStyles.xStyleText(colorText: Colors.green, fontSize: 24, activeBold: false),
                                ))
                          : Container()
                    ])));
          });
        });

    return null;
  }

  Future<bool?>? xOnSaveXMedia(List<XMediaItem> liXMedia, XFDataItem item) async {
    return true;
  }

  Future<bool?>? xOnSaveXMedia_INTERNAL(List<XMediaItem> liXMedia, XFDataItem item) async {
    return await xOnSaveXMedia(liXMedia, item);
  }

  Future<bool?>? xOnDelXMedia_INTERNAL(XMediaItem xMedia) async {
    var res = await showDialog<bool?>(
      context: context,
      builder: (context) {
        return XAlertDialog(
          title_Text: "Sicuro di voler cancellare il Media ${xMedia.blobURL}?",
          title_Style: XStyles.xStyTextForSubLabel(XColors.warning),
          btnNO_label: "Annulla",
          btnYES_label: "Si",
          btnNO_OnPressed: () => Navigator.pop(context, false),
          btnYES_OnPressed: () => Navigator.pop(context, true),
        );
      },
    );
    if (res != null && res) {
      late Directory direct;
      direct = Directory("${XLibStorage.filePath}/XMEDIAS/");
      direct.listSync().removeWhere((element) => element.path.contains(xMedia.id));
      setState(() {
        liMediaRAW.remove(xMedia);
      });
      res = await xOnDelXMedia(xMedia);
      return res;
    } else {
      return false;
    }
  }

  Future<bool?>? xOnDelXMedia(XMediaItem xMedia) async {
    return true;
  }

  Future<XMediaItem> xOnBefore_TakeXMedia(XMediaItem xclMedia, XFDataItem idParent) async {
    return xclMedia;
  }

  xMedia_onTake_handling(Uint8List file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem, int mediatype) async {
    setState(() {
      isBusy = false;
    });
    var bytesForPayLoad = await file;
    var t = XMediaItem(Uuid().v4(), xDocID: xfDataItem.id, mediaType: mediatype, payload: bytesForPayLoad, isNew: true);
    var x = await xOnBefore_TakeXMedia(t, xfDataItem);
    var xclMedia = x;
    // per ora non lo mettiamo visto che sendDataBack lo prende dal loaclPATH e lo mette lui lì
    // payload: await file.readAsBytes(),
    final xFile = File("${XLibStorage.filePath}/XMEDIAs/${xclMedia.id}_.${extForMediaType(xclMedia.mediaType!)}"); // _ è il marker per DONE !
    await xFile.create(recursive: true).then((value) async => await xFile.writeAsBytes(bytesForPayLoad)).whenComplete(() async {
      if (mediatype == XEnums.mediaType.video.value)
        xclMedia.miniatura = await generateVideoThumbnail(xFile.path);
      else if (mediatype == XEnums.mediaType.image.value) {
        xclMedia.miniatura = await createThumbnails_fromImage(bytesForPayLoad);
      }
    });

    xclMedia.localURI = xFile.path;
    setState(() => liMediaRAW.add(xclMedia));
  }

  Uint8List createThumbnails_fromImage(Uint8List image_payload, {int width = 80, int height = 100}) {
    final imgOri = img.decodeJpg(image_payload)!;
    var resizedImg = img.copyResize(imgOri, width: width, height: height);
    final pngBytes = img.encodePng(resizedImg);
    return pngBytes;
  }

  static String extForMediaType(int mediatype) => mediatype == XEnums.mediaType.video.value
      ? "mp4"
      : mediatype == XEnums.mediaType.image.value
          ? "jpg"
          : "aac";

  onSave_EditedPicture(bool isBusy, void Function(void Function()) setState, XMediaItem xfDataItem) async {
    rebuildAllChildren(context);
  }

  Future<Uint8List?> generateVideoThumbnail(String blobURL) async {
    var x = await thumb.VideoThumbnail.thumbnailData(
      video: blobURL,
      imageFormat: thumb.ImageFormat.PNG,
      maxWidth: 128, // specify the width of the thumbnail, let the height auto-scaled to keep the source aspect ratio
      quality: 25,
    );
    return x;
  }

  Widget xActionsItem_AddMedia(XFDataItem item) {
    return XBtnbase(
      icon: Icons.photo_camera_outlined,
      icon_Size: 22,
      width: actionsBTN_Width,
      height: actionsBTN_Height,
      toolTip_Message: XfxToolTips.BTN_GetXMedia,
      decoration: BoxDecoration(color: actionsBTN_Color, border: Border.all(width: 1, color: actionsBTN_BorderColor), borderRadius: BorderRadius.all(Radius.circular(10))),
      icon_Color: Colors.orange,
      onPressed: () async => await cmd_GetMedia(setState, item).then((value) => setState(() {})),
    );
  }

  ///Widget per la costruzione dell'Head all'interno dei Dettagli
  Widget xDett_Item_HeadWidget(dynamic itemDett, void Function(void Function()) parentSetState, {XView? xclViewUI}) {
    ScrollController? _scrollController = ScrollController();
    return Scrollbar(
        thumbVisibility: true,
        controller: _scrollController,
        child: SingleChildScrollView(
            controller: _scrollController,
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              mainAxisSize: MainAxisSize.min,
              children: widget.showHead ? xLayout_Render_HeadView(xclViewUI!, border_Visible: false) : [],
            )));
  }

  ///Widget per la costruzione di ItemComplessi utilizzati nei Dettagli della Scheda
  List<XPopUpMenuItem> liPopUpMenu_ActionOnItem = List<XPopUpMenuItem>.empty(growable: true);
  buildXItem<T extends XFDataItem, K extends XFDataItem?>(
    T item,
    void Function(void Function()) parentSetState, {
    List<dynamic>? liChildrens,
    Widget Function(dynamic)? dettItem,
    Function(T)? onLongPress_MainItem,
    Function(T)? BTNadd_cmdAdd,
    String? BTNadd_label,
    Widget? mainWidget,
    Color? backGround_Color,
    Color? border_Color,
    Widget Function(dynamic)? dettWidget,
    EdgeInsetsGeometry? margin,
    List<XPopUpMenuItem>? liPopUpMenu_Items,
    List<XAction>? liActions_Items,
    bool border_Visible = false,
    bool title_InMainWidget_Visible = false,
    XView? xView_Scheda,
    XView? xView_Elenco,
    XView? xViewDett,
    List<Widget>? titleLiWidgets,
    bool viewDett_Data = false,
    bool showXMedia_Always = false,
    bool viewXMediaUI = false,
    BorderRadiusGeometry? borderRadius_Item,
  }) {
    return StatefulBuilder(
      builder: (context, setState) {
        GlobalKey<PopupMenuButtonState> popUp_Key = GlobalKey<PopupMenuButtonState>();
        liPopUpMenu_ActionOnItem.clear();
        liPopUpMenu_ActionOnItem.add(XPopUpMenuItem(
            title: "Modifica",
            color: Colors.yellow,
            icon: Icons.edit,
            toolTip_Message: XfxToolTips.BTN_Modifica,
            onPressed: (context, obj) async {
              Navigator.pop(context);
              var res = await xPreview_Dialog(xView_Elenco!, obj);
              if (res != null) {
                item = res.getCloneFull() as T;
                widget.itemEdited != null ? widget.itemEdited!(item) : null;
              }
              return obj;
            }));
        // liPopUpMenu_ActionOnItem.add(XPopUpMenuItem(
        //     title: "Apri la Scheda",
        //     color: Colors.blue,
        //     toolTip_Message: XfxToolTips.BTN_OpenScheda,
        //     icon: Icons.file_open_outlined,
        //     onPressed: (context, item) async {
        //       Navigator.pop(context);
        //       var res = await xPreview_Dialog(xView_Scheda!, item);
        //       if (res != null) {
        //         item = res.getCloneFull() as T;
        //         widget.itemEdited != null ? widget.itemEdited!(item) : null;
        //       }
        //     }));
        liPopUpMenu_ActionOnItem.add(XPopUpMenuItem(
            title: "Aggiungi Nota",
            color: Colors.green,
            toolTip_Message: "Aggiungi una nota nei media",
            icon: Icons.file_open_outlined,
            onPressed: (context, item) async {
              // //TODO
              // //Chiudo il popup
              // Navigator.pop(context);
              // //Creo l'xMedia di appoggio
              // var xMedia = XMediaItem(Uuid().v4(), isNew: true, mediaType: XEnums.mediaType.image.value);
              // //lo metto nello storage
              // // await xMedia_onTake_handling(xMedia.payload!, isBusy.value, setState, item, xMedia.mediaType!);
              // item.showXMedia = true;
              // // if (item is K)
              // //   widget.rootItemEdited != null ? widget.rootItemEdited!(item) : null;
              // // else
              // widget.itemEdited != null ? widget.itemEdited!(item) : null;

              // var res = await cmd_OpenAreaNote(xMedia, item, withImage: false);
              // if (res != null && res) {
              //   await xOnSaveXMedia_INTERNAL(liMediaRAW, item)?.then((value) => Navigator.pop(context, true));
              // } else {}
              // liXMedias_MediaRecorder.value.clear();
            }));
        if (liPopUpMenu_Items != null) {
          liPopUpMenu_ActionOnItem.addAll(liPopUpMenu_Items);
        }
        var xMedia_Empty = liMediaRAW.where((element) => element.xDocID == item.id).isEmpty;
        return Container(
            margin: EdgeInsets.only(bottom: 4),
            child: XElencoItem(item, xView_Scheda!, xViewDetts: xViewDett, liXActions: liActions_Items, margin: margin ?? EdgeInsets.only(left: 4, right: 4, bottom: 4), changeStatoWithTap: false, onTapItem: () async {
              if ((liChildrens == null || liChildrens.isEmpty) && xMedia_Empty) {
              } else {
                parentSetState(() => item.isShowDetails = item.isShowDetails.not());
              }
            },
                showTrailingArrow: false,
                decorationBackGroundContainer: BoxDecoration(
                    borderRadius: borderRadius_Item,
                    color: backGround_Color ?? Colors.grey[900],
                    border: border_Visible
                        ? Border(
                            left: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                            right: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                            top: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                            bottom: item.isShowDetails ? BorderSide(color: border_Color ?? backGround_Color ?? Colors.grey[900]!) : BorderSide.none,
                          )
                        : null),
                showingDetails: item.isShowDetails,
                showMainWithDetails: true,
                childMain: Column(
                  mainAxisSize: MainAxisSize.min,
                  children: [
                    InkWell(
                        onLongPress: () {
                          onLongPress_MainItem!(item);
                        },
                        onTap: () {
                          setState(() {
                            item.isShowDetails = item.isShowDetails.not();
                          });
                        },
                        child: Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                          //Icona di Expand della riga
                          mainWidget != null || ((liChildrens == null || liChildrens.isEmpty)) ? Container() : Container(margin: EdgeInsets.only(right: 4), child: Icon((item.isShowDetails) ? Icons.arrow_upward_rounded : Icons.account_tree_outlined, color: XColors.foregroundLight)),

                          //Area della composizione dei dati
                          mainWidget != null
                              ? Container()
                              : xView_Elenco != null && widget.showHead
                                  ? Expanded(
                                      child: Row(
                                          children: xView_Elenco.cols.length == 2
                                              ? xView_Elenco.cols.map((xCol) => xLayout_Item_RowWidgets(xCol, item)).toList() //
                                              : [
                                                  xView_Elenco.cols.where((xcol) => xcol.colKey.startsWith("li").not()).length == 1
                                                      ? Expanded(
                                                          child: Container(child: Text(item[xView_Elenco.cols.where((xcol) => xcol.colKey.startsWith("li").not()).first.colKey], style: XStyles.xStyTextForDescr(Colors.white), overflow: TextOverflow.fade)),
                                                        )
                                                      : Expanded(child: Wrap(children: xLayout_RenderDett_HeadDataView(xView_Elenco, item, border_Visible: false)))
                                                ]),
                                    )
                                  : Container(),
                          mainWidget != null ? Expanded(flex: 2, child: mainWidget) : Container(),

                          //BTN di visione degli XMedia
                          xMedia_Active
                              ? Container(
                                  margin: EdgeInsets.only(top: 3, right: 5, bottom: 3),
                                  child: XBtnbase(
                                      width: actionsBTN_Width,
                                      height: actionsBTN_Height,
                                      decoration: BoxDecoration(color: actionsBTN_Color, border: Border.all(width: 1, color: (showXMedia_Always || item.showXMedia) ? Colors.purple[600]! : actionsBTN_BorderColor), borderRadius: BorderRadius.all(Radius.circular(10))),
                                      toolTip_Message: XfxToolTips.BTN_ShowXMedia,
                                      icon_WidthArea: 25,
                                      icon: xMedia_Empty.not()
                                          ? (showXMedia_Always || item.showXMedia)
                                              ? Icons.visibility_off
                                              : Icons.visibility
                                          : Icons.visibility_off,
                                      icon_Size: 22,
                                      onPressed: () {
                                        if (xMedia_Empty.not()) {
                                          FocusScope.of(context).unfocus();
                                          setState(() {
                                            item.showXMedia = item.showXMedia.not();
                                          });
                                        }
                                      },
                                      elevation: 0,
                                      label_Color: XColors.foregroundLight,
                                      icon_Color: xMedia_Empty ? Colors.grey[800] : Colors.purple[600]))
                              : Container(),

                          // //BTN di Edit della riga
                          // Container(margin: EdgeInsets.only(top: 2, right: 4, bottom: 2), child: xActionsItem_ViewDett(item, viewDett_Data, setState, xView_Elenco!)),

                          //BTN di add degli XMedia
                          xMedia_Active ? Container(margin: EdgeInsets.only(top: 3, right: 4, bottom: 3), child: xActionsItem_AddMedia(item)) : Container(),

                          //BTN di add dei dettagli dell'Item
                          BTNadd_cmdAdd != null
                              ? Container(
                                  margin: EdgeInsets.only(top: 3, right: 5, bottom: 3),
                                  child: XBtnbase(
                                      width: actionsBTN_Width,
                                      height: actionsBTN_Height,
                                      icon_WidthArea: 25,
                                      toolTip_Message: XfxToolTips.BTN_AddDett,
                                      icon: Icons.add,
                                      icon_Size: 22,
                                      onPressed: () {
                                        FocusScope.of(context).unfocus();
                                        BTNadd_cmdAdd(item);
                                        item.isShowDetails = true;
                                      },
                                      elevation: 0,
                                      decoration: BoxDecoration(color: actionsBTN_Color, border: Border.all(width: 1, color: actionsBTN_BorderColor), borderRadius: BorderRadius.all(Radius.circular(10))),
                                      label_Color: XColors.foregroundLight,
                                      icon_Color: XColors.done))
                              : Container(),
                          //Se liPopUpMenu_Items è piena ti mostro l'icona delle azioni che ti apre un popUpmenu
                          liPopUpMenu_ActionOnItem != null
                              ? Container(
                                  height: actionsBTN_Height,
                                  width: actionsBTN_Width,
                                  margin: EdgeInsets.only(top: 3, bottom: 3),
                                  decoration: BoxDecoration(color: actionsBTN_Color, border: Border.all(width: 1, color: actionsBTN_BorderColor), borderRadius: BorderRadius.all(Radius.circular(10))),
                                  child: PopupMenuButton(
                                    padding: EdgeInsets.all(0),
                                    key: popUp_Key,
                                    tooltip: "Vedi azioni",
                                    icon: Icon(Icons.more_vert_outlined),
                                    itemBuilder: (context) {
                                      return liPopUpMenu_ActionOnItem
                                          .map((e) => PopupMenuItem(
                                              height: 40,
                                              child: XBtnbase(
                                                decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                                                height: 40,
                                                width: (e.iconImage != null || e.icon != null) ? 250 : 150,
                                                label: e.title,
                                                icon_WidthArea: 50,
                                                label_Style: XStyles.xStyTextForSubLabel(e.color),
                                                icon_Widget: e.icon != null ? null : Container(width: 50, child: e.iconImage),
                                                icon: e.iconImage != null ? null : e.icon,
                                                icon_Size: 23,
                                                icon_Color: e.iconImage != null ? null : e.color,
                                                toolTip_Message: e.toolTip_Message,
                                                onPressed: () => e.onPressed!(context, item),
                                              )))
                                          .toList();
                                    },
                                    iconSize: 22,
                                  ))
                              : Container(),
                        ])),
                    xMedia_Active && (showXMedia_Always || item.showXMedia)
                        ? Container(
                            child: Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
                            //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA
                            (liMediaRAW.isNotEmpty && liMediaRAW.any((element) => element.xDocID == item.id))
                                ? Container(
                                    margin: EdgeInsets.all(3),
                                    decoration: BoxDecoration(border: Border.all(color: Colors.grey[700]!)),
                                    child: Column(children: [
                                      Row(children: [
                                        Expanded(
                                            child: Wrap(
                                          alignment: WrapAlignment.center,
                                          runAlignment: WrapAlignment.center,
                                          spacing: 5,
                                          runSpacing: 5,
                                          children: liMediaRAW.where((element) => element.xDocID == item.id).map((e) {
                                            if (e.mediaType == XEnums.mediaType.audio.value) {
                                              return builder_AudioWidget(e, item);
                                            } else if (e.mediaType == XEnums.mediaType.video.value) {
                                              return builder_VideoWidget(e, liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.video.value).toList(), setState: setState);
                                            } else {
                                              return builder_ImmaginiWidget(e, item, setState);
                                            }
                                          }).toList(),
                                        ))
                                      ]),
                                    ]),
                                  )
                                : Container(),
                            //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA  //// AREA XMEDIA
                          ]))
                        : Container(),
                  ],
                ),
                childDetails: Column(
                  children: [
                    dettWidget != null
                        ? dettWidget(item)
                        : dettItem != null
                            ? liChildrens != null
                                ? Wrap(
                                    spacing: 5,
                                    runSpacing: 5,
                                    children: liChildrens.map((xclVoce) {
                                      return dettItem(xclVoce);
                                    }).toList())
                                : Container()
                            : Container(),
                  ],
                )));
      },
    );
  }

  Future<XMediaItem?> xOnGetXMedia(XMediaItem item) async {
    return item;
  }

  Future loadMedia(dynamic xMedia) async {
    xMedia as XMediaItem;
    if (xMedia.payload != null) {
    } else if (xMedia.payload == null && xMedia.localURI != "") {
      File(xMedia.localURI!).readAsBytes().then((value) => xMedia.payload = value);
    } else if (xMedia.payload == null && xMedia.localURI == "") {
      await xOnGetXMedia(xMedia).then((x) {
        if (x != null) {
          xMedia.payload = x.payload;
          xMedia.overlaySurface = x.overlaySurface;
        }
      });
    }
  }

  Widget builder_ImmaginiWidget(XMediaItem xMedia, XFDataItem item, void Function(void Function()) setState, {DateTime? dt}) {
    return InkWell(
      onLongPress: () async => await xOnDelXMedia_INTERNAL(xMedia),
      onTap: () => cmd_OpenPhoto(xMedia, item, dtImage: dt),
      child: Container(
          color: (xMedia.payload == null && xMedia.overlaySurface != null) ? Colors.white : Colors.transparent,
          width: 80,
          child: Stack(
            children: xMedia.miniatura == null && xMedia.payload == null
                ? [Container(width: 80, height: 100, color: Colors.grey[800], child: Icon(Icons.block, size: 30, color: Colors.white))]
                : [
                    Stack(alignment: Alignment.topRight, children: [
                      Container(
                          child: Stack(children: [
                        Image.memory(xMedia.miniatura ?? xMedia.payload!, width: 80, height: 100),
                        // xMedia.overlaySurface == null //
                        //     ? Container() //
                        //     : Image.memory(xMedia.overlaySurface!, width: 80, height: 100)
                      ])),
                      // (xMedia.hasOverlaySurface ?? false) ? Container(decoration: BoxDecoration(color: Colors.black.withAlpha(80), borderRadius: BorderRadius.all(Radius.circular(20))), child: Icon(Icons.edit, color: Colors.blueAccent)) : Container(),
                    ])
                  ],
          )),
    );
  }

  // Future cmd_OpenAreaNote(XMediaItem xMedia, XFDataItem item, {DateTime? dtImage, bool withImage = true}) async {
  //   xMedia.isSel = true;
  //   var res = await showDialog<bool?>(
  //       context: context,
  //       builder: (context) {
  //         return StatefulBuilder(builder: (context, setState) {
  //           if (xMedia.payload == null) {
  //             Future.sync(() async => await loadMedia(xMedia)).then((value) => setState(() => xMedia.isSel = false));
  //           } else {
  //             setState(() => xMedia.isSel = false);
  //           }
  //           return XAlertDialog(
  //               child: xMedia.isSel
  //                   ? XStatefulWidgetBase.LoaderIndicator(xMedia.isSel)
  //                   : Stack(
  //                       alignment: Alignment.topLeft,
  //                       children: [
  //                         Container(
  //                             decoration: BoxDecoration(color: Colors.white),
  //                             margin: EdgeInsets.only(bottom: 20),
  //                             child: ImagePainter.signature(
  //                               xMedia: xMedia,
  //                               height: MediaQuery.of(context).size.height,
  //                               width: MediaQuery.of(context).size.width + 20,
  //                               key: _imagePainterBlockNoteState_Key,
  //                               signatureBgColor: Colors.white,
  //                               controlsAtTop: true,
  //                               colors: [Colors.yellow, Colors.black, Colors.red, Colors.white, Colors.purple, Colors.blue, Colors.green],
  //                             )),
  //                       ],
  //                     ),
  //               title_Text: dtImage != null ? "Nota del ${XUtils.dateToString(dtImage, format: "dd/MM/yy")}" : "Nota",
  //               title_Style: XStyles.xStyTextForLabel(Colors.yellow),
  //               content_insetPadding: EdgeInsets.symmetric(horizontal: 4),
  //               actionsBTNarea_Padding: EdgeInsets.all(0),
  //               actionsBTNarea_Child: Row(children: [
  //                 Expanded(
  //                     child: XBtnbase(
  //                   height: 35,
  //                   backGroundColor: Colors.transparent,
  //                   onPressed: () => Navigator.pop(context, null),
  //                   elevation: 0,
  //                   label: "Chiudi",
  //                   label_Style: TextStyle(fontSize: 20, color: Colors.red),
  //                 )),
  //                 Expanded(
  //                     child: XBtnbase(
  //                   height: 35,
  //                   backGroundColor: Colors.transparent,
  //                   onPressed: () async {
  //                     Navigator.pop(context, false);
  //                   },
  //                   elevation: 0,
  //                   label: "Più carta",
  //                   label_Style: TextStyle(fontSize: 20, color: Colors.amber),
  //                 )),
  //                 Expanded(
  //                     child: XBtnbase(
  //                   height: 35,
  //                   backGroundColor: Colors.transparent,
  //                   onPressed: () => Navigator.pop(context, true),
  //                   elevation: 0,
  //                   label: "Salva",
  //                   label_Style: TextStyle(fontSize: 20, color: Colors.green),
  //                 ))
  //               ]));
  //         });
  //       });
  //   if (res != null) {
  //     if (res) {
  //       xMedia.overlaySurface = await _imagePainterBlockNoteState_Key.currentState!.exportImage();
  //       xMedia.hasOverlaySurface = true;
  //       xMedia.isModified = true;
  //       if (withImage) {
  //         if (xMedia.miniatura == null) {
  //           var x = createThumbnails_fromImage(xMedia.payload!);
  //           createThumbnailsWithOverlay(xMedia.overlaySurface!, x);
  //         } else {
  //           createThumbnailsWithOverlay(xMedia.overlaySurface!, xMedia.miniatura!);
  //         }
  //       } else {
  //         if (xMedia.isNew) {
  //           await xMedia_onTake_handling(xMedia.overlaySurface!, isBusy.value, setState, item, XEnums.mediaType.image.value);
  //         }
  //       }

  //       // diciamo al padre (SCHEDA) che è stato modificato qlcs
  //       if (item is K)
  //         widget.rootItemEdited != null ? widget.rootItemEdited!(item as K) : null;
  //       else
  //         widget.itemEdited != null ? widget.itemEdited!(item) : null;

  //       cmd_OnAfter_EditPhoto();
  //     } else {
  //       xMedia.overlaySurface = await createMorePaper(xMedia.overlaySurface!).then((value) {
  //         cmd_OpenAreaNote(xMedia, item, dtImage: dtImage, withImage: true);
  //       });
  //     }
  //   }
  //   return res;
  // }

  cmd_OpenPhoto(XMediaItem xMedia, XFDataItem item, {DateTime? dtImage}) async {
    xMedia.isSel = true;
    var res = await showDialog<bool?>(
        context: context,
        builder: (context) {
          return ImagePainter.signature(
            xMedia: xMedia,
            height: MediaQuery.of(context).size.height / 1.2,
            width: MediaQuery.of(context).size.width,
            loadMedia: (xclMedia) async => await loadMedia(xclMedia),
            key: _imagePainterState_Key,
          );
        });
    xMedia.isSel = false;
    if (res != null && res) {
      // xMedia.overlaySurface = await _imagePainterState_Key.currentState!.exportImage();
      // print(xMedia.overlaySurface!.length);
      // if (xMedia.miniatura == null) {
      //   var x = createThumbnails_fromImage(xMedia.payload!);
      //   createThumbnailsWithOverlay(xMedia.overlaySurface!, x);
      // } else {
      //   createThumbnailsWithOverlay(xMedia.overlaySurface!, xMedia.miniatura!);
      // }

      // diciamo al padre (SCHEDA) che è stato modificato qlcs
      if (item is K)
        widget.rootItemEdited != null ? widget.rootItemEdited!(item as K) : null;
      else
        widget.itemEdited != null ? widget.itemEdited!(item) : null;

      setState(() {
        xMedia.isModified = true;
      });
      cmd_OnAfter_EditPhoto();
    } else {}
  }

  cmd_OpenVideo(XMediaItem xMedia, List<XMediaItem> liVideo, {String? pathPreviewVideo, void Function(void Function())? setState}) async {
    isBusy.value = false;
    setState!(() {
      waiterMessage = "Caricamento del Video, Attendi un attimo..";
      xMedia.isSel = true;
    });
    if (xMedia.payload == null) {
      // var res = appServices.get
      await xOnGetXMedia(xMedia).then((x) {
        if (x != null) {
          xMedia.payload = x.payload;
        }
      });
    }
    xMedia.isSel = false;

    bool _isPlaying = false;
    Future<void> _playVideo() async {
      await videoPlayerController!.play();
      setState(() {});
    }

    Future<void> _pauseVideo() async {
      await videoPlayerController!.pause();
      setState(() {});
    }

    Future<void> _stopVideo() async {
      await videoPlayerController!.pause();
      await videoPlayerController!.seekTo(Duration.zero);
      setState(() {});
    }

    bool isPlaying;
    File x = await (xMedia.localURI != "" || pathPreviewVideo != null) ? File.fromUri(Uri.parse(pathPreviewVideo ?? xMedia.localURI!)) : File("${XLibStorage.filePath}/XMEDIAS/${xMedia.id}_.mp4");
    await x.create(recursive: true);
    await x.writeAsBytes(xMedia.payload!).then((value) async {
      videoPlayerController = await VideoPlayerController.file(value, videoPlayerOptions: VideoPlayerOptions(allowBackgroundPlayback: true));

      await videoPlayerController!
        ..addListener(() {
          isPlaying = videoPlayerController!.value.isPlaying;
          if (isPlaying != _isPlaying) {
            setState(() {
              _isPlaying = isPlaying;
            });
          }
        })
        ..initialize().then((_) {
          setState(() {});
        });
      await videoPlayerController!.play();
      // setState(() {
      //   _isLoaded.value = true;
      // });
      return await showDialog(
          context: context,
          builder: (context) {
            var i = liVideo.firstWhereOrNull((element) => element.xDocID == element.id) != null;
            return StatefulBuilder(builder: (context, setState) {
              var isPlay = videoPlayerController!.value.isPlaying;
              return XAlertDialog(
                  content_insetPadding: EdgeInsets.all(0),
                  title_TextAlign: TextAlign.center,
                  actionsBTNarea_Padding: EdgeInsets.all(0),
                  title_Text: i ? "Video del Lavoro" : "Video del Dettaglio",
                  actionsBTNarea_Child: Row(
                    children: [
                      isPlay
                          ? Expanded(
                              child: XBtnbase(
                              label: "Restart",
                              onPressed: () {
                                setState(() {
                                  _stopVideo();
                                  isPlay = false;
                                });
                              },
                              label_Style: XStyles.xStyTextForLabel(Colors.yellow),
                            ))
                          : Container(),
                      Expanded(
                          child: XBtnbase(
                        label: isPlay ? "Pausa" : "Play",
                        onPressed: () {
                          setState(() {
                            if (isPlay) {
                              _pauseVideo();
                              isPlay = false;
                            } else {
                              _playVideo();
                              isPlay = true;
                            }
                          });
                        },
                        label_Style: XStyles.xStyTextForLabel(Colors.green),
                      )),
                      Expanded(
                          child: XBtnbase(
                        label: "Chiudi",
                        onPressed: () {
                          videoPlayerController!.dispose();
                          Navigator.pop(context);
                        },
                        label_Style: XStyles.xStyTextForLabel(Colors.red),
                      ))
                    ],
                  ),
                  child: Stack(children: [
                    InkWell(
                        child: Container(
                          width: MediaQuery.of(context).size.width,
                          height: MediaQuery.of(context).size.height,
                          child: VideoPlayer(videoPlayerController!),
                        ),
                        onTap: () {
                          setState(() {
                            if (isPlay) {
                              _pauseVideo();
                              isPlay = false;
                            } else {
                              _playVideo();
                              isPlay = true;
                            }
                          });
                          // if (videoPlayerController.value.isPlaying) {
                          //   _pauseVideo();
                          // } else {
                          //   _playVideo();
                          // }
                        })
                  ]));
            });
          }).whenComplete(() {
        setState(() {
          waiterMessage = "";
          isBusy.value = true;
        });
      });
    });
  }

  cmd_OpenAudio(XMediaItem audio, XFDataItem item, bool isPreview) async {
    await showDialog(
        context: context,
        builder: (context) {
          return XAlertDialog(
              height: 150,
              actionsBTNarea_Child: Row(children: [
                Expanded(
                    child: XBtnbase(
                        label: "Chiudi",
                        label_Color: Colors.red,
                        onPressed: () {
                          playerController.stopPlayer();
                          playerController.dispose();
                          Navigator.pop(context);
                        }))
              ]),
              child: builder_AudioArea(audio, isPreview),
              title_Text: "");
        });
  }

  Future<Uint8List?>? cmd_OnAfter_EditPhoto() async {
    return null;
  }

  Widget builder_VideoWidget(XMediaItem video, List<XMediaItem> liVideo, {void Function(void Function())? setState}) {
    return InkWell(
      onLongPress: () async => await xOnDelXMedia_INTERNAL(video),
      onTap: () async {
        cmd_OpenVideo(video, liVideo, setState: setState);
      },
      child: Container(
          decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(video.miniatura!))),
          width: 80,
          height: 100,
          child: Container(
            child: Icon(Icons.play_arrow, size: 28),
          )),
    );
  }

  Widget builder_AudioArea(XMediaItem? audio, bool isPreview) {
    if (playerController.waveformData.isEmpty) {
      isPreview ? _preparePlayer_WhenInPreview(audio!) : _preparePlayer(audio!);
    }
    return Align(
        alignment: Alignment.centerLeft,
        child: Container(
            padding: EdgeInsets.only(bottom: 6, right: 10, top: 6),
            margin: EdgeInsets.symmetric(vertical: 8, horizontal: 12),
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(10),
              color: Color(0xFF343145),
            ),
            child: Row(mainAxisSize: MainAxisSize.min, children: [
              // if (!controller.playerState.isStopped)
              IconButton(
                  onPressed: () async {
                    if (playerController.playerState.isPlaying.not()) {
                      await playerController.startPlayer(finishMode: FinishMode.pause);
                    } else {
                      await playerController.pausePlayer();
                    }
                  },
                  icon: Icon(playerController.playerState.isPlaying ? Icons.stop : Icons.play_arrow),
                  color: Colors.white,
                  splashColor: Colors.transparent,
                  highlightColor: Colors.transparent),
              Expanded(
                  child: AudioFileWaveforms(
                size: Size(MediaQuery.of(context).size.width / 2, 70),
                playerController: playerController,
                enableSeekGesture: true,
                waveformType: WaveformType.fitWidth,
                playerWaveStyle: PlayerWaveStyle(
                  fixedWaveColor: Colors.white54,
                  liveWaveColor: Colors.blueAccent,
                  spacing: 6,
                  showBottom: true,
                  showSeekLine: true,
                  showTop: true,
                ),
              ))
            ])));
  }

  Widget builder_AudioWidget(XMediaItem? audio, XFDataItem xclItem) {
    // _preparePlayer(audio!);
    return Container(
      alignment: Alignment.center,
      height: 100,
      width: 80,
      color: Colors.grey[800],
      child: Row(
        mainAxisAlignment: MainAxisAlignment.center,
        crossAxisAlignment: CrossAxisAlignment.center,
        mainAxisSize: MainAxisSize.min,
        children: [
          // if (!controller.playerState.isStopped)
          IconButton(
            onPressed: () async {
              await xOnGetXMedia(audio!).then((x) {
                if (x != null) {
                  audio.payload = x.payload;
                }
              });
              await showDialog(
                  context: context,
                  builder: (context) {
                    return XAlertDialog(
                        height: 150,
                        actionsBTNarea_Child: Row(children: [
                          Expanded(
                              child: XBtnbase(
                                  label: "Chiudi",
                                  label_Color: Colors.red,
                                  onPressed: () {
                                    playerController.stopPlayer();
                                    playerController.dispose();
                                    Navigator.pop(context);
                                  }))
                        ]),
                        child: builder_AudioArea(audio, false),
                        title_Text: "");
                  });
            },
            icon: Icon(playerController.playerState.isPlaying ? Icons.stop : Icons.mic, size: 24),
            color: Colors.white,
            splashColor: Colors.transparent,
            highlightColor: Colors.transparent,
          ),
        ],
      ),
    );
  }

  List<Widget> xLayout_RenderDett_HeadDataView(XView xview, dynamic item, {bool border_Visible = true}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = widget.view!.cols
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((xCol) {
              var xwidgt = Container(
                  padding: EdgeInsets.symmetric(horizontal: 2, vertical: widget.pageMode_Active ? 2 : 3),
                  // decoration: BoxDecoration(
                  //   color: (xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight : xCol.xmodelXprop.col_Color).withAlpha(40),
                  //   border: Border.all(width: 1, color: xCol.xmodelXprop.col_Color == Color(0xff000000) ? XColors.foregroundLight.withAlpha(150) : xCol.xmodelXprop.col_Color.withAlpha(150)),
                  // ),
                  constraints: BoxConstraints(minWidth: xCol.width * XUtils.kforScale),
                  child: xLayout_Item_RowWidgets(xCol, item));
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }
}

class XPopUpMenuItem {
  String? title;
  String? toolTip_Message;
  Color? color;
  IconData? icon;
  Image? iconImage;
  Function(BuildContext, dynamic)? onPressed;
  XPopUpMenuItem({
    this.color,
    this.onPressed,
    this.title,
    this.icon,
    this.iconImage,
    this.toolTip_Message,
  });
}

class XFilterEl<T> {
  XFilterEl(this.xPropOfItemToFilter, {this.All}) {
    this.Value = this.All;
  }
  List<T> Items = List<T>.empty(growable: true);
  // late T Current;
  T? All;
  T? Value;
  late XProp xPropOfItemToFilter;
  List<XProp> ColsOfXFdataItemToShow = List<XProp>.empty(growable: true);

  static XFilterEl<XEnumDef> fromXEnumDefs(XProp xPropOfItemToFilter, XEnum xEnum, {String all_label = "TUTTI", int all_value = -1, dynamic initialValue}) {
    var xf = XFilterEl<XEnumDef>(xPropOfItemToFilter, All: (all_value < 0 ? null : XEnumDef(label: all_label, value: all_value, backColor: XColors.backgroundDark, textColor: XColors.foregroundLight)));
    xf.Items = xEnum.definitions.values.toList();
    if (initialValue != null) {
      xf.Value = initialValue;
    }
    return xf;
  }

  static XFilterEl from<T>(XProp xPropOfItemToFilter, List<T> items, {T? All, dynamic initialValue}) {
    var xf = XFilterEl<T>(xPropOfItemToFilter, All: All);
    xf.Items = items;
    if (initialValue != null) {
      xf.Value = initialValue;
    }
    return xf;
  }
}
